import gui.CellImageAnalyzer;
import gui.CellImageAnalyzerView;

import ij.IJ;

import java.awt.BorderLayout;
import java.awt.Label;
import java.awt.Panel;

import javax.swing.JLabel;
import javax.swing.JMenu;
import javax.swing.JPanel;
import javax.swing.JFrame;
import javax.swing.JMenuBar;
import java.awt.Toolkit;

public class MRIVisualScriptingView extends JFrame {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1567585955179391335L;
	private JPanel jContentPane = null;
	private JMenuBar jJMenuBar = null;

	/**
	 * This is the default constructor
	 */
	public MRIVisualScriptingView() {
		super();
		initialize();
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		this.setSize(300, 84);
		this.setIconImage(Toolkit.getDefaultToolkit().getImage(getClass().getResource("/resource_images/icon.gif")));
		this.setJMenuBar(getJJMenuBar());
		this.setContentPane(getJContentPane());
		this.setTitle("MRI Visual Scripting");
		this.addWindowListener(new java.awt.event.WindowAdapter() {
			public void windowClosing(java.awt.event.WindowEvent e) {
				dispose();
			}
		});
		CellImageAnalyzer analyzer = CellImageAnalyzer.getCurrent();
		CellImageAnalyzerView analyzerView = analyzer.getView();
		JMenu operationsMenu = analyzerView.getOperationsMenu();
		JMenu applicationsMenu = analyzerView.getApplicationsMenu();
		JMenu aboutMenu = analyzerView.getAboutMenu();
		this.getJMenuBar().add(operationsMenu);
		this.getJMenuBar().add(applicationsMenu);
		this.getJMenuBar().add(aboutMenu);
		Label label = analyzerView.getJLabel();
		Panel panel = (Panel)IJ.getInstance().getComponent(1);//.getComponentAt(0,0)
		panel.add(label,0);
	}

	/**
	 * This method initializes jContentPane
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJContentPane() {
		if (jContentPane == null) {
			jContentPane = new JPanel();
			jContentPane.setLayout(new BorderLayout());
		}
		return jContentPane;
	}

	/**
	 * This method initializes jJMenuBar	
	 * 	
	 * @return javax.swing.JMenuBar	
	 */
	private JMenuBar getJJMenuBar() {
		if (jJMenuBar == null) {
			jJMenuBar = new JMenuBar();
		}
		return jJMenuBar;
	}

}  //  @jve:decl-index=0:visual-constraint="10,10"
