/*
 * Created on 29.11.2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package analysisOperations;

import ij.ImagePlus;
import ij.measure.ResultsTable;
import operations.Operation;

/**
 * @author Volker
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class ComputeMomentsOperation extends Operation {
	/**
	 * 
	 */
	private static final long serialVersionUID = -6794489744685353555L;
	ResultsTable moments;
	ImagePlus momentsImage;
	
	protected void initialize() throws ClassNotFoundException {
		super.initialize();
		parameterTypes = new Class[1];
		parameterTypes[0] = Class.forName("ij.ImagePlus");
		parameterNames = new String[1];
		parameterNames[0] = "InputImage";
		resultTypes = new Class[2];
		resultTypes[0] = Class.forName("ij.measure.ResultsTable");
		resultTypes[1] = Class.forName("ij.ImagePlus");
		resultNames = new String[2];
		resultNames[0] = "Moments";
		resultNames[1] = "MomentsImage";
	}
	/**
	 * @return Returns the moments.
	 */
	public ResultsTable getMoments() {
		if (moments==null) {
			moments = new ResultsTable();
		}
		return moments;
	}
	/**
	 * @param moments The moments to set.
	 */
	public void setMoments(ResultsTable moments) {
		this.moments = moments;
	}
	/**
	 * @return Returns the momentsImage.
	 */
	public ImagePlus getMomentsImage() {
		return momentsImage;
	}
	/**
	 * @param momentsImage The momentsImage to set.
	 */
	public void setMomentsImage(ImagePlus momentsImage) {
		this.momentsImage = momentsImage;
	}
	
	public void doIt() {
		CentralMomentCalculator calc = new CentralMomentCalculator();
		calc.setImage(this.getInputImage());
		calc.calculate();
		writeHeadings();
		writeValues(calc);
	}

	/**
	 * @param calc
	 */
	private void writeValues(CentralMomentCalculator calc) {
		ResultsTable moments = this.getMoments();
		moments.incrementCounter();
		moments.addValue(0, calc.cm00);
		
		moments.addValue(1, calc.cm10);
		moments.addValue(2, calc.cm01);
		
		moments.addValue(3, calc.cm20);
		moments.addValue(4, calc.cm02);
		moments.addValue(5, calc.cm11);
		
		moments.addValue(6, calc.cm30);
		moments.addValue(7, calc.cm03);
		moments.addValue(8, calc.cm21);
		moments.addValue(9, calc.cm12);
		
		moments.addValue(10, calc.feature[0]);
		moments.addValue(11, calc.feature[1]);
		moments.addValue(12, calc.feature[2]);
		moments.addValue(13, calc.feature[3]);
		moments.addValue(14, calc.feature[4]);
		moments.addValue(15, calc.feature[5]);
		moments.addValue(16, calc.feature[6]);
	}

	/**
	 * 
	 */
	private void writeHeadings() {
		ResultsTable moments = this.getMoments();
		moments.reset();
		moments.setHeading(0,"m00");
	
		moments.setHeading(1,"m10");
		moments.setHeading(2,"m01");
		
		moments.setHeading(3,"m20");
		moments.setHeading(4,"m02");
		moments.setHeading(5,"m11");
	
		moments.setHeading(6,"m30");
		moments.setHeading(7,"m03");
		moments.setHeading(8,"m21");
		moments.setHeading(9,"m12");
		
		moments.setHeading(10, "f1");
		moments.setHeading(11, "f2");
		moments.setHeading(12, "f3");
		moments.setHeading(13, "f4");
		moments.setHeading(14, "f5");
		moments.setHeading(15, "f6");
		moments.setHeading(16, "f7");
	}
}
