/*
 * Created on 18.08.2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package analysisOperations;

import java.awt.geom.Line2D;
import java.awt.geom.Point2D;
import java.util.Vector;

import gui.Option;
import ij.gui.NewImage;
import ij.measure.ResultsTable;
import ij.process.ImageProcessor;
import operations.Operation;

/**
 * @author Volker
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class FindEndsOperation extends Operation {
	/**
	 * 
	 */
	private static final long serialVersionUID = -4446934063805091395L;
	
	protected ResultsTable centerPoints;
	protected Option maxGapSize;
	protected Option threshold;
	
	protected Vector resultLines;
	
	protected void initialize() throws ClassNotFoundException {
		super.initialize();
		parameterTypes = new Class[2];
		parameterTypes[0] = Class.forName("ij.ImagePlus");
		parameterTypes[1] = Class.forName("ij.measure.ResultsTable");
		parameterNames = new String[2];
		parameterNames[0] = "InputImage";
		parameterNames[1] = "CenterPoints";
		optionsNames = new String[2];
		optionsNames[0] = "maxGapSize";
		optionsNames[1] = "threshold";
		resultTypes = new Class[2];
		resultTypes[0] = Class.forName("ij.ImagePlus");
		resultTypes[1] = Class.forName("java.util.Vector");
		resultNames = new String[2];
		resultNames[0] = "Result";
		resultNames[1] = "ResultLines";
	}
	
	/**
	 * @return Returns the centerPoints.
	 */
	public ResultsTable getCenterPoints() {
		return centerPoints;
	}
	/**
	 * @param centerPoints The centerPoints to set.
	 */
	public void setCenterPoints(ResultsTable centerPoints) {
		this.centerPoints = centerPoints;
	}
	/**
	 * @return Returns the maxGapSize.
	 */
	public float getMaxGapSize() {
		return maxGapSize.getFloatValue();
	}
	/**
	 * @param maxGapSize The maxGapSize to set.
	 */
	public void setMaxGapSize(float maxGapSize) {
		this.maxGapSize.setValue(Float.valueOf(maxGapSize).toString());
	}
	/**
	 * @return Returns the resultLines.
	 */
	public Vector getResultLines() {
		return resultLines;
	}
	/**
	 * @param resultLines The resultLines to set.
	 */
	public void setResultLines(Vector resultLines) {
		this.resultLines = resultLines;
	}
	/**
	 * @return Returns the threshold.
	 */
	public float getThreshold() {
		return threshold.getFloatValue();
	}
	/**
	 * @param threshold The threshold to set.
	 */
	public void setThreshold(float threshold) {
		this.threshold.setValue(Float.valueOf(threshold).toString());
	}
	
	protected void setupOptions() {
		super.setupOptions();
		this.setThreshold(0);
		this.setMaxGapSize(5);
	}
	
	public void connectOptions() {
		this.maxGapSize = (Option) this.options.getOptions().elementAt(0);
		this.threshold = (Option) this.options.getOptions().elementAt(1);
	}
	
	protected void cleanUpInput() {
		super.cleanUpInput();
		this.setCenterPoints(null);
	}
	
	public void doIt() {
		result = NewImage.createByteImage(inputImage.getTitle(), inputImage.getWidth(), inputImage.getHeight(), 
				1, NewImage.GRAY8);
		resultLines = new Vector();
		for (int i=0; i<centerPoints.getCounter(); i++) {
			float x = centerPoints.getValue(ResultsTable.X_CENTROID, i);
			float y = centerPoints.getValue(ResultsTable.Y_CENTROID, i);
			Point2D center = new Point2D.Float(x,y);
			Point2D left = this.findLeftEnd(center, i+1);
			Point2D right = this.findRightEnd(center, i+1);
			Line2D aSegment = new Line2D.Float(left,right);
			boolean skip = false;
			for (int j=0; j<resultLines.size(); j++) {
				Line2D currentSegment = (Line2D) resultLines.elementAt(j);
				if (currentSegment.intersectsLine(aSegment)) skip = true;
			}
			if (skip) continue;
			resultLines.add(aSegment);
		}
		this.drawLines();
	}

	/**
	 * 
	 */
	private void drawLines() {
		for (int i=0; i<resultLines.size();i++) {
			Line2D aLine = (Line2D) resultLines.elementAt(i);
			result.getProcessor().drawLine((int)Math.round(aLine.getX1()), 
										   (int)Math.round(aLine.getY1()), 
										   (int)Math.round(aLine.getX2()), 
										   (int)Math.round(aLine.getY2()));
		}
		
	}
	/**
	 * @param center
	 * @return
	 */
	private Point2D findEnd(Point2D center, int slice, int sign) {
		/** TODO search snap point around middle to start with
		 ** - create freehand roi instead of line  
		 **/
		ImageProcessor ip = inputImage.getStack().getProcessor(slice);
		int x = (int)Math.round(center.getX());
		int y = (int)Math.round(center.getY());
		int lastDir = -1;
		while(x>=0 && y>=0 && x<ip.getWidth() && y<ip.getHeight()) {
			float left = ip.getPixelValue(x+sign,y);
			float up = ip.getPixelValue(x,y-1);
			float down = ip.getPixelValue(x,y+1);
			int dir = 9;
			float value = left;
			if (lastDir != 6 && up>left && up>down) {dir = 0; value = up;}
			if (lastDir != 0 && down>left && down>up) {dir = 6; value = down;}
			if (value>this.getThreshold()) {
				if (dir==9) x = x + sign;
				if (dir==0) y--;
				if (dir==6) y++;
				lastDir = dir;
				continue;
			} 
			for (int i=2; i<this.getMaxGapSize(); i++) {
				value = ip.getPixelValue(x+(sign*i),y);
				if (value>this.getThreshold()) {
					x = x + (sign*i);
					break;
				}
			}
			if (value<=this.getThreshold()) break;
			
		}
		Point2D result = new Point2D.Float(x,y);
		return result;
	}
	/**
	 * @param center
	 * @return
	 */
	private Point2D findLeftEnd(Point2D center, int slice) {
		return findEnd(center, slice, -1);
	}
	
	/**
	 * @param center
	 * @return
	 */
	private Point2D findRightEnd(Point2D center, int slice) {
		return findEnd(center, slice, 1);
	}
}
