/*
 * Created on 29.06.2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package analysisOperations;

import operations.Operation;
import gui.BooleanOption;
import gui.Option;
import gui.Options;
import ij.IJ;
import ij.ImagePlus;
import ij.measure.ResultsTable;
import ij.plugin.filter.ParticleAnalyzer;
import imagejProxies.SilentParticleAnalyzer;

/**
 * @author Volker
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class FindObjectsOperation extends Operation {
	/**
	 * 
	 */
	private static final long serialVersionUID = -6870468713039447989L;
	ResultsTable measurements;
	ImagePlus mask;
	ImagePlus outlines;
	
	Option minSize;
	Option maxSize;
	
	BooleanOption displayLabels;
	BooleanOption excludeEdgeObjects;
	BooleanOption invertY;
	BooleanOption limitToThreshold;
	
	BooleanOption measureArea;
	BooleanOption measureBounds;
	BooleanOption measureCenterOfMass;
	BooleanOption measureCentroids;
	BooleanOption measureCircularity;
	BooleanOption measureFeret;
	BooleanOption measureFitEllipse;
	BooleanOption measureIntegratedDensity;
	BooleanOption measureMean;
	BooleanOption measureMinMaxGrayValue;
	BooleanOption measureMode;
	BooleanOption measurePerimeter;
	BooleanOption measureStandardDeviation;

	protected void initialize() throws ClassNotFoundException {
		super.initialize();
		parameterTypes = new Class[1];
		parameterTypes[0] = Class.forName("ij.ImagePlus");
		parameterNames = new String[1];
		parameterNames[0] = "InputImage";
		setupOptionNames();
		resultTypes = new Class[3];
		resultTypes[0] = Class.forName("ij.measure.ResultsTable");
		resultTypes[1] = Class.forName("ij.ImagePlus");
		resultTypes[2] = Class.forName("ij.ImagePlus");
		resultNames = new String[3];
		resultNames[0] = "Measurements";
		resultNames[1] = "Mask";
		resultNames[2] = "Outlines";
	}

	protected void setupOptionNames() {
		optionsNames = new String[19];
		optionsNames[0] = "min size";
		optionsNames[1] = "max size";
		optionsNames[2] = "display labels";
		optionsNames[3] = "exclude edge objects";
		optionsNames[4] = "invert y";
		optionsNames[5] = "limit to threshold";
		optionsNames[6] = "measure area";
		optionsNames[7] = "measure bounds";
		optionsNames[8] = "measure center of mass";
		optionsNames[9] = "measure centroids";
		optionsNames[10] = "measure circularity";
		optionsNames[11] = "Feret's diameter";
		optionsNames[12] = "measure fit ellipse";
		optionsNames[13] = "integrated density";
		optionsNames[14] = "measure mean";
		optionsNames[15] = "measure min & max";
		optionsNames[16] = "modal gray value";
		optionsNames[17] = "measure perimeter";
		optionsNames[18] = "standard deviation";
	}
	
	/**
	 * @return Returns the excludeEdgeObjects.
	 */
	public boolean getExcludeEdgeObjects() {
		return excludeEdgeObjects.getBooleanValue();
	}
	/**
	 * @param excludeEdgeObjects The excludeEdgeObjects to set.
	 */
	public void setExcludeEdgeObjects(boolean excludeEdgeObjects) {
		this.excludeEdgeObjects.setValue(new Boolean(excludeEdgeObjects).toString());
	}
	/**
	 * @return Returns the maxSize.
	 */
	public int getMaxSize() {
		return maxSize.getIntegerValue();
	}
	/**
	 * @param maxSize The maxSize to set.
	 */
	public void setMaxSize(int maxSize) {
		this.maxSize.setValue(new Integer(maxSize).toString());
	}
	/**
	 * @return Returns the measureCentroids.
	 */
	public boolean getMeasureCentroids() {
		return measureCentroids.getBooleanValue();
	}
	/**
	 * @param measureCentroids The measureCentroids to set.
	 */
	public void setMeasureCentroids(boolean measureCentroids) {
		this.measureCentroids.setValue(new Boolean(measureCentroids).toString());
	}
	/**
	 * @return Returns the measurements.
	 */
	public ResultsTable getMeasurements() {
		if (measurements==null) {
			measurements = new ResultsTable();
		}
		return measurements;
	}
	/**
	 * @param measurements The measurements to set.
	 */
	public void setMeasurements(ResultsTable measurements) {
		this.measurements = measurements;
	}
	/**
	 * @return Returns the minSize.
	 */
	public int getMinSize() {
		return minSize.getIntegerValue();
	}
	/**
	 * @param minSize The minSize to set.
	 */
	public void setMinSize(int minSize) {
		this.minSize.setValue(new Integer(minSize).toString());	
		}
	
	/**
	 *  
	 */
	public void doIt() {
		ResultsTable measurements = this.getMeasurements();
		measurements.reset();
		SilentParticleAnalyzer analyzer = new SilentParticleAnalyzer(this.getOptionsWord(), 
				this.getMeasurementsWord(), 
				measurements,
				this.getMinSize(),
				this.getMaxSize());
		int previousShowChoice = SilentParticleAnalyzer.getShowChoice();
		SilentParticleAnalyzer.setShowChoice(2);
		analyzer.analyze(this.getInputImage(), this.getInputImage().getProcessor());
		IJ.showStatus(measurements.getCounter() + " objects found");
		mask = analyzer.getOutlineImage();
		SilentParticleAnalyzer.setShowChoice(previousShowChoice);
		this.computeOutlines();
	}

	/**
	 * @return Returns the mask.
	 */
	public ImagePlus getMask() {
		return mask;
	}
	/**
	 * @param mask The mask to set.
	 */
	public void setMask(ImagePlus mask) {
		this.mask = mask;
	}

	/**
	 * @return
	 */
	protected int getMeasurementsWord() {
		int result = 0;
		if (this.getMeasureArea()) {
			result = result | ParticleAnalyzer.AREA; 
		}
		if (this.getMeasureBounds()) { 
			result = result | ParticleAnalyzer.RECT;
		}
		if (this.getMeasureCenterOfMass()) { 
			result = result | ParticleAnalyzer.CENTER_OF_MASS;
		}
		if (this.getMeasureCentroids()) {
			result = result | ParticleAnalyzer.CENTROID; 
		}
		if (this.getMeasureCircularity()) { 
			result = result | ParticleAnalyzer.CIRCULARITY;
		}
		if (this.getMeasureFeret()) { 
			result = result | ParticleAnalyzer.FERET;
		}
		if (this.getMeasureFitEllipse()) { 
			result = result | ParticleAnalyzer.ELLIPSE;
		}
		if (this.getMeasureIntegratedDensity()) { 
			result = result | ParticleAnalyzer.INTEGRATED_DENSITY;
		}
		if (this.getMeasureMean()) { 
			result = result | ParticleAnalyzer.MEAN;
		}
		if (this.getMeasureMinMaxGrayValue()) { 
			result = result | ParticleAnalyzer.MIN_MAX;
		}
		if (this.getMeasureMode()) { 
			result = result | ParticleAnalyzer.MODE;
		}
		if (this.getMeasurePerimeter()) { 
			result = result | ParticleAnalyzer.PERIMETER;
		}
		if (this.getMeasureStandardDeviation()) { 
			result = result | ParticleAnalyzer.STD_DEV;
		}
		return result;
	}

	/**
	 * @return
	 */
	protected boolean getMeasureStandardDeviation() {
		return this.measureStandardDeviation.getBooleanValue();
	}

	/**
	 * @return
	 */
	protected boolean getMeasureMode() {
		return this.measureMode.getBooleanValue();
	}

	/**
	 * @return
	 */
	protected boolean getMeasureMinMaxGrayValue() {
		return this.measureMinMaxGrayValue.getBooleanValue();
	}

	/**
	 * @return
	 */
	protected boolean getMeasureMean() {
		return this.measureMean.getBooleanValue();
	}

	/**
	 * @return
	 */
	protected boolean getMeasureIntegratedDensity() {
		return this.measureIntegratedDensity.getBooleanValue();
	}

	/**
	 * @return
	 */
	protected boolean getMeasureFitEllipse() {
		return this.measureFitEllipse.getBooleanValue();
	}

	/**
	 * @return
	 */
	protected boolean getMeasureFeret() {
		return this.measureFeret.getBooleanValue();
	}

	/**
	 * @return
	 */
	protected boolean getMeasureCenterOfMass() {
		return this.measureCenterOfMass.getBooleanValue();
	}

	/**
	 * @return
	 */
	protected boolean getMeasureArea() {
		return this.measureArea.getBooleanValue();	
	}

	/**
	 * @return
	 */
	protected int getOptionsWord() {
		int result = 0;
		if (this.getDisplayLabels()) {
			result = result | ParticleAnalyzer.LABELS;
		}
		if (this.getExcludeEdgeObjects()) {
			result = result | ParticleAnalyzer.EXCLUDE_EDGE_PARTICLES;
		}
		if (this.getInvertY()) {
			result = result | ParticleAnalyzer.INVERT_Y;
		}
		if (this.getLimitToThreshold()) {
			result = result | ParticleAnalyzer.LIMIT;
		}
		return result;
	}

	/**
	 * @return
	 */
	protected boolean getLimitToThreshold() {
		return this.limitToThreshold.getBooleanValue();
	}

	/**
	 * @return
	 */
	protected boolean getInvertY() {
		return this.invertY.getBooleanValue();
	}

	/**
	 * @return
	 */
	protected boolean getDisplayLabels() {
		return this.displayLabels.getBooleanValue();
	}

	/**
	 * 
	 */
	protected void showResult() {
		this.getMeasurements().show("result from find objects");
	}
	/**
	 * @return Returns the measureCircularity.
	 */
	public boolean getMeasureCircularity() {
		return measureCircularity.getBooleanValue();
	}
	/**
	 * @param measureCircularity The measureCircularity to set.
	 */
	public void setMeasureCircularity(boolean measureCircularity) {
		this.measureCircularity.setValue(new Boolean(measureCircularity).toString());
	}
	/**
	 * @return Returns the measurePerimeter.
	 */
	public boolean getMeasurePerimeter() {
		return measurePerimeter.getBooleanValue();
	}
	/**
	 * @param measurePerimeter The measurePerimeter to set.
	 */
	public void setMeasurePerimeter(boolean measurePerimeter) {
		this.measurePerimeter.setValue(new Boolean(measurePerimeter).toString());
	}
	
	/**
	 * @return Returns the measurePerimeter.
	 */
	public boolean getMeasureBounds() {
		return measureBounds.getBooleanValue();
	}
	/**
	 * @param measurePerimeter The measurePerimeter to set.
	 */
	public void setMeasureBounds(boolean measureBounds) {
		this.measureBounds.setValue(new Boolean(measureBounds).toString());
	}
	
	protected void setupOptions() {
		options = new Options(); 
		options.setName(this.name() + " options");
		String[] optionsNames = this.getOptionsNames();
		// min 
		this.minSize = new Option();
		this.setMinSize(10);
		minSize.setName(optionsNames[0]);
		options.add(this.minSize);
		// max
		this.maxSize = new Option();
		maxSize.setName(optionsNames[1]);
		this.setMaxSize(999999);
		options.add(this.maxSize);
		// display labels
		this.displayLabels = new BooleanOption();
		this.setDisplayLabels(true);
		displayLabels.setName(optionsNames[2]);
		options.add(this.displayLabels);
		// exclude edge objects
		this.excludeEdgeObjects = new BooleanOption();
		this.setExcludeEdgeObjects(true);
		excludeEdgeObjects.setName(optionsNames[3]);
		options.add(this.excludeEdgeObjects);
		// invert y
		this.invertY = new BooleanOption();
		this.setInvertY(false);
		invertY.setName(optionsNames[4]);
		options.add(this.invertY);
		// limit to threshold
		this.limitToThreshold = new BooleanOption();
		this.setLimitToThreshold(false);
		limitToThreshold.setName(optionsNames[5]);
		options.add(this.limitToThreshold);
		// area
		this.measureArea = new BooleanOption();
		this.setMeasureArea(false);
		measureArea.setName(optionsNames[6]);
		options.add(this.measureArea);
		// bounds
		this.measureBounds = new BooleanOption();
		this.setMeasureBounds(true);
		measureBounds.setName(optionsNames[7]);
		options.add(this.measureBounds);
		// center of mass
		this.measureCenterOfMass = new BooleanOption();
		this.setMeasureCenterOfMass(false);
		measureCenterOfMass.setName(optionsNames[8]);
		options.add(this.measureCenterOfMass);
		// ccentroids
		this.measureCentroids = new BooleanOption();
		this.setMeasureCentroids(true);
		measureCentroids.setName(optionsNames[9]);
		options.add(this.measureCentroids);
		// circularity
		this.measureCircularity = new BooleanOption();
		this.setMeasureCircularity(true);
		measureCircularity.setName(optionsNames[10]);
		options.add(this.measureCircularity);
		// deret's diameter
		this.measureFeret = new BooleanOption();
		this.setMeasureFeret(false);
		measureFeret.setName(optionsNames[11]);
		options.add(this.measureFeret);
		// ellipse
		this.measureFitEllipse = new BooleanOption();
		this.setMeasureFitEllipse(false);
		measureFitEllipse.setName(optionsNames[12]);
		options.add(this.measureFitEllipse);
		// integrated density
		this.measureIntegratedDensity = new BooleanOption();
		this.setMeasureIntegratedDensity(false);
		measureIntegratedDensity.setName(optionsNames[13]);
		options.add(this.measureIntegratedDensity);
		// mean
		this.measureMean = new BooleanOption();
		this.setMeasureMean(false);
		measureMean.setName(optionsNames[14]);
		options.add(this.measureMean);
		// min max
		this.measureMinMaxGrayValue = new BooleanOption();
		this.setMeasureMinMaxGrayValue(false);
		measureMinMaxGrayValue.setName(optionsNames[15]);
		options.add(this.measureMinMaxGrayValue);
		// modal gray value
		this.measureMode = new BooleanOption();
		this.setMeasureMode(false);
		measureMode.setName(optionsNames[16]);
		options.add(this.measureMode);
		// perimeter
		this.measurePerimeter = new BooleanOption();
		this.setMeasurePerimeter(true);
		measurePerimeter.setName(optionsNames[17]);
		options.add(this.measurePerimeter);
		// standard deviation
		this.measureStandardDeviation = new BooleanOption();
		this.setMeasureStandardDeviation(false);
		measureStandardDeviation.setName(optionsNames[18]);
		options.add(this.measureStandardDeviation);
	}

	/**
	 * @param b
	 */
	protected void setMeasureStandardDeviation(boolean b) {
		this.measureStandardDeviation.setValue(Boolean.valueOf(b).toString());
	}

	/**
	 * @param b
	 */
	protected void setMeasureMode(boolean b) {
		this.measureMode.setValue(Boolean.valueOf(b).toString());
	}

	/**
	 * @param b
	 */
	protected void setMeasureMinMaxGrayValue(boolean b) {
		this.measureMinMaxGrayValue.setValue(Boolean.valueOf(b).toString());
	}

	/**
	 * @param b
	 */
	protected void setMeasureMean(boolean b) {
		this.measureMean.setValue(Boolean.valueOf(b).toString());
	}

	/**
	 * @param b
	 */
	protected void setMeasureIntegratedDensity(boolean b) {
		this.measureIntegratedDensity.setValue(Boolean.valueOf(b).toString());
	}

	/**
	 * @param b
	 */
	protected void setMeasureFitEllipse(boolean b) {
		this.measureFitEllipse.setValue(Boolean.valueOf(b).toString());
	}

	/**
	 * @param b
	 */
	protected void setMeasureFeret(boolean b) {
		this.measureFeret.setValue(Boolean.valueOf(b).toString());
	}

	/**
	 * @param b
	 */
	protected void setMeasureCenterOfMass(boolean b) {
		this.measureCenterOfMass.setValue(Boolean.valueOf(b).toString());
	}

	/**
	 * @param b
	 */
	protected void setMeasureArea(boolean b) {
		this.measureArea.setValue(Boolean.valueOf(b).toString());
	}

	/**
	 * @param b
	 */
	protected void setLimitToThreshold(boolean b) {
		this.limitToThreshold.setValue(Boolean.valueOf(b).toString());
	}

	/**
	 * @param b
	 */
	protected void setInvertY(boolean b) {
		this.invertY.setValue(Boolean.valueOf(b).toString());
		
	}

	/**
	 * @param b
	 */
	protected void setDisplayLabels(boolean b) {
		this.displayLabels.setValue(Boolean.valueOf(b).toString());
	}

	public void connectOptions() {
		this.minSize = (Option) this.options.getOptions().elementAt(0);
		this.maxSize = (Option) this.options.getOptions().elementAt(1);
		this.displayLabels = (BooleanOption) this.options.getOptions().elementAt(2);
		this.excludeEdgeObjects = (BooleanOption) this.options.getOptions().elementAt(3);
		this.invertY = (BooleanOption) this.options.getOptions().elementAt(4);
		this.limitToThreshold = (BooleanOption) this.options.getOptions().elementAt(5);
		
		this.measureArea = (BooleanOption) this.options.getOptions().elementAt(6);
		this.measureBounds = (BooleanOption) this.options.getOptions().elementAt(7);
		this.measureCenterOfMass = (BooleanOption) this.options.getOptions().elementAt(8);
		this.measureCentroids = (BooleanOption) this.options.getOptions().elementAt(9);
		this.measureCircularity = (BooleanOption) this.options.getOptions().elementAt(10);
		this.measureFeret = (BooleanOption) this.options.getOptions().elementAt(11);
		this.measureFitEllipse = (BooleanOption) this.options.getOptions().elementAt(12);
		this.measureIntegratedDensity = (BooleanOption) this.options.getOptions().elementAt(13);
		this.measureMean = (BooleanOption) this.options.getOptions().elementAt(14);
		this.measureMinMaxGrayValue = (BooleanOption) this.options.getOptions().elementAt(15);
		this.measureMode = (BooleanOption) this.options.getOptions().elementAt(16);
		this.measurePerimeter = (BooleanOption) this.options.getOptions().elementAt(17);
		this.measureStandardDeviation = (BooleanOption) this.options.getOptions().elementAt(18);
	}
	
	public void computeOutlines() {
		ResultsTable measurements = new ResultsTable();
		measurements.reset();
		SilentParticleAnalyzer analyzer = new SilentParticleAnalyzer(this.getOptionsWord(), 
				this.getMeasurementsWord(), 
				measurements,
				this.getMinSize(),
				this.getMaxSize());
		int previousShowChoice = SilentParticleAnalyzer.getShowChoice();
		SilentParticleAnalyzer.setShowChoice(1);
		analyzer.analyze(this.getInputImage(), this.getInputImage().getProcessor());
		outlines = analyzer.getOutlineImage();
		SilentParticleAnalyzer.setShowChoice(previousShowChoice);
	}
	/**
	 * @return Returns the outlines.
	 */
	public ImagePlus getOutlines() {
		return outlines;
	}
	/**
	 * @param outlines The outlines to set.
	 */
	public void setOutlines(ImagePlus outlines) {
		this.outlines = outlines;
	}
}
