/*
 * Created on 12.08.2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package analysisOperations;

import gui.Option;
import ij.ImagePlus;
import ij.process.ByteProcessor;
import nj.Costs;
import operations.Operation;

/**
 * @author Volker
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class HessianOperation extends Operation {
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 6675567290826774434L;
	protected HessianImage hessian;
	protected Option scale;
	
	protected void initialize() throws ClassNotFoundException {
		super.initialize();
		parameterTypes = new Class[1];
		parameterTypes[0] = Class.forName("ij.ImagePlus");
		parameterNames = new String[1];
		parameterNames[0] = "InputImage";
		optionsNames = new String[1];
		optionsNames[0] = "scale";
		resultTypes = new Class[1];
		resultTypes[0] = Class.forName("analysisOperations.HessianImage");
		resultNames = new String[1];
		resultNames[0] = "Hessian";
	}
	/**
	 * @return Returns the hessian.
	 */
	public HessianImage getHessian() {
		return hessian;
	}
	/**
	 * @param hessian The hessian to set.
	 */
	public void setHessian(HessianImage hessian) {
		this.hessian = hessian;
	}
	
	public void doIt() {
		ImagePlus inputImage = this.getInputImage();
		result = this.getCopyOfOrReferenceTo(inputImage, inputImage.getTitle());
		Costs costsCalculator = new Costs();
		float[][][] costs = costsCalculator.run((ByteProcessor)result.getProcessor(), this.getScale());
		hessian = new HessianImage();
		hessian.setHessian(costs);
	}
	
	protected void setupOptions() {
		super.setupOptions();
		this.setScale(2.0f);
		this.scale.setMin(0);
		this.scale.setShortHelpText("the derivative smoothing scale");
	}
	
	public void connectOptions() {
		this.scale = (Option) this.options.getOptions().elementAt(0);
	}
	/**
	 * @return Returns the scale.
	 */
	public float getScale() {
		return scale.getFloatValue();
	}
	/**
	 * @param f The scale to set.
	 */
	public void setScale(float f) {
		this.scale.setValue(new Float(f).toString());
	}
	
	/**
	 * 
	 */
	protected void showResult() {
		this.getHessian().getImage().show();
	}
}
