/*
 * Created on 17.11.2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package analysisOperations;

import ij.IJ;
import ij.measure.ResultsTable;
import ij.text.TextWindow;
import imagejProxies.SilentAnalyzer;
import gui.BooleanOption;
import gui.Options;

/**
 * @author Volker
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class MeasureOperation extends FindObjectsOperation {
	/**
	 * 
	 */
	private static final long serialVersionUID = 492489307720350606L;

	protected void initialize() throws ClassNotFoundException {
		super.initialize();
		parameterTypes = new Class[1];
		parameterTypes[0] = Class.forName("ij.ImagePlus");
		parameterNames = new String[1];
		parameterNames[0] = "InputImage";
		setupOptionNames();
		resultTypes = new Class[1];
		resultTypes[0] = Class.forName("ij.measure.ResultsTable");
		resultNames = new String[1];
		resultNames[0] = "Measurements";
	}

	protected void setupOptionNames() {
		optionsNames = new String[13];
		optionsNames[0] = "measure area";
		optionsNames[1] = "measure bounds";
		optionsNames[2] = "measure center of mass";
		optionsNames[3] = "measure centroids";
		optionsNames[4] = "measure circularity";
		optionsNames[5] = "Feret's diameter";
		optionsNames[6] = "measure fit ellipse";
		optionsNames[7] = "integrated density";
		optionsNames[8] = "measure mean";
		optionsNames[9] = "measure min & max";
		optionsNames[10] = "modal gray value";
		optionsNames[11] = "measure perimeter";
		optionsNames[12] = "standard deviation";
	}
	
	public void doIt() {
		ResultsTable measurements = this.getMeasurements();
		measurements.reset();
		SilentAnalyzer analyzer = new SilentAnalyzer(this.getInputImage(), 
										 this.getMeasurementsWord(), 
										 measurements);
		analyzer.setup("", this.getInputImage());
		analyzer.run(this.getInputImage().getProcessor());
		if (this.getInputImage().getRoi()!= null && this.getInputImage().getRoi().isLine()) {
			((TextWindow)(IJ.getTextPanel().getParent())).close();
		}
	}
	
	protected void setupOptions() {
		options = new Options(); 
		options.setName(this.name() + " options");
		String[] optionsNames = this.getOptionsNames();
		// area
		this.measureArea = new BooleanOption();
		this.setMeasureArea(false);
		measureArea.setName(optionsNames[0]);
		options.add(this.measureArea);
		// bounds
		this.measureBounds = new BooleanOption();
		this.setMeasureBounds(true);
		measureBounds.setName(optionsNames[1]);
		options.add(this.measureBounds);
		// center of mass
		this.measureCenterOfMass = new BooleanOption();
		this.setMeasureCenterOfMass(false);
		measureCenterOfMass.setName(optionsNames[2]);
		options.add(this.measureCenterOfMass);
		// ccentroids
		this.measureCentroids = new BooleanOption();
		this.setMeasureCentroids(true);
		measureCentroids.setName(optionsNames[3]);
		options.add(this.measureCentroids);
		// circularity
		this.measureCircularity = new BooleanOption();
		this.setMeasureCircularity(true);
		measureCircularity.setName(optionsNames[4]);
		options.add(this.measureCircularity);
		// deret's diameter
		this.measureFeret = new BooleanOption();
		this.setMeasureFeret(false);
		measureFeret.setName(optionsNames[5]);
		options.add(this.measureFeret);
		// ellipse
		this.measureFitEllipse = new BooleanOption();
		this.setMeasureFitEllipse(false);
		measureFitEllipse.setName(optionsNames[6]);
		options.add(this.measureFitEllipse);
		// integrated density
		this.measureIntegratedDensity = new BooleanOption();
		this.setMeasureIntegratedDensity(false);
		measureIntegratedDensity.setName(optionsNames[7]);
		options.add(this.measureIntegratedDensity);
		// mean
		this.measureMean = new BooleanOption();
		this.setMeasureMean(false);
		measureMean.setName(optionsNames[8]);
		options.add(this.measureMean);
		// min max
		this.measureMinMaxGrayValue = new BooleanOption();
		this.setMeasureMinMaxGrayValue(false);
		measureMinMaxGrayValue.setName(optionsNames[9]);
		options.add(this.measureMinMaxGrayValue);
		// modal gray value
		this.measureMode = new BooleanOption();
		this.setMeasureMode(false);
		measureMode.setName(optionsNames[10]);
		options.add(this.measureMode);
		// perimeter
		this.measurePerimeter = new BooleanOption();
		this.setMeasurePerimeter(true);
		measurePerimeter.setName(optionsNames[11]);
		options.add(this.measurePerimeter);
		// standard deviation
		this.measureStandardDeviation = new BooleanOption();
		this.setMeasureStandardDeviation(false);
		measureStandardDeviation.setName(optionsNames[12]);
		options.add(this.measureStandardDeviation);
	}
	
	public void connectOptions() {
		this.measureArea = (BooleanOption) this.options.getOptions().elementAt(0);
		this.measureBounds = (BooleanOption) this.options.getOptions().elementAt(1);
		this.measureCenterOfMass = (BooleanOption) this.options.getOptions().elementAt(2);
		this.measureCentroids = (BooleanOption) this.options.getOptions().elementAt(3);
		this.measureCircularity = (BooleanOption) this.options.getOptions().elementAt(4);
		this.measureFeret = (BooleanOption) this.options.getOptions().elementAt(5);
		this.measureFitEllipse = (BooleanOption) this.options.getOptions().elementAt(6);
		this.measureIntegratedDensity = (BooleanOption) this.options.getOptions().elementAt(7);
		this.measureMean = (BooleanOption) this.options.getOptions().elementAt(8);
		this.measureMinMaxGrayValue = (BooleanOption) this.options.getOptions().elementAt(9);
		this.measureMode = (BooleanOption) this.options.getOptions().elementAt(10);
		this.measurePerimeter = (BooleanOption) this.options.getOptions().elementAt(11);
		this.measureStandardDeviation = (BooleanOption) this.options.getOptions().elementAt(12);
	}
}
