/*
 * Created on 30.06.2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package applications;

import java.awt.Point;
import java.awt.Rectangle;
import java.awt.event.MouseEvent;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.Serializable;
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Vector;

import javax.swing.SwingUtilities;

import operations.Operation;

import gui.CellImageAnalyzer;
import gui.Option;
import gui.Options;
import gui.Parameter;

/**
 * @author Volker
 * 
 * TODO To change the template for this generated type comment go to Window -
 * Preferences - Java - Code Style - Code Templates
 */
public class Application extends Operation implements Serializable {

	/**
	 * 
	 */
	private static final long serialVersionUID = -3098504249448555530L;
	protected Vector operations;
	protected Vector inputMaps;
	protected ApplicationView applicationView;
	protected Parameter parameter;
	static protected Vector openApplicationViews = new Vector();
	protected HashMap deleteAfterMap;
	protected int programCounter;
	protected boolean stopped;
	
	String path;
	
	public Application() {
		super();
	}

	public void initialize() {
		operations = new Vector();
		inputMaps = new Vector();
	}

	public void stop() {
		stopped = true;
		this.cleanUp();
	}
	
	protected void setupDeleteAfterOperation() {
		int[][] deleteAfterOperation;
		deleteAfterOperation = new int[operations.size()][];
		for (int i=0; i<operations.size(); i++) {
			Operation operation = (Operation) (operations
					.elementAt(i));
			int[] results = null;
			for(int j=0; j<operation.getNumberOfResults(); j++) {
				if (results==null) {
					results = new int[operation.getNumberOfResults()];
					deleteAfterOperation[i] = results;
				}
				for (int k=i+1; k<operations.size(); k++) {
					Operation target = (Operation) (operations
							.elementAt(k));
					int targetIndex = k;
					if (this.isInLoop(target)) {
						targetIndex = indexOfNextLoopEndAfter(target);
					}
					
					for (int l=0; l<target.getNumberOfParameter(); l++) {
						int[] map = target.getInputMapForParameter(l);
						if (map[0]==i && map[1]==j) {
							deleteAfterOperation[i][j] = targetIndex;
						}
					}
				}
			}
		}
		setupDeleteAfterMap(deleteAfterOperation);
	}

	/**
	 * @param deleteAfterOperation
	 */
	private void setupDeleteAfterMap(int[][] deleteAfterOperation) {
		deleteAfterMap = new HashMap();
		for (int i=0; i<deleteAfterOperation.length; i++) {
			int[] list = deleteAfterOperation[i];
			if (list==null) continue;
			for (int j=0; j<list.length; j++) {
				int delAfter = list[j];
				int resultNr = j;
				int fromOp = i;
				Integer key = new Integer(delAfter);
				if (!deleteAfterMap.containsKey(key)) {
					deleteAfterMap.put(key, new Vector());
				}
				int[] map = new int[2];
				map[0] = fromOp;
				map[1] = resultNr;
				((Vector)deleteAfterMap.get(key)).add(map);
			}
		}
	}

	public void doIt() {
		this.cleanUp();
		this.resetPathOptions();
		if (stopped) {
			stopped = false;
			return;
		}
		this.setupDeleteAfterOperation();
		int inputIndex = 1;
		this.setProgressMax(operations.size());
		for (programCounter = 0; programCounter < operations.size(); programCounter++) {
			if (applicationView!=null) {
				applicationView.repaint();
			}
			this.setProgress(programCounter);
			Operation operation = (Operation) (operations
					.elementAt(programCounter));
			if (stopped) {
				stopped = false;
				return;
			}
			operation.execute();
			try {
				operation.getTask().join();
				if (!operation.isLoopEnd()) {
					this.cleanupResultsAfter(programCounter);
				}
			} catch (InterruptedException e1) {
				// TODO Auto-generated catch block
				e1.printStackTrace();
			}
			if (programCounter < operations.size() - 1) {
				Operation nextOperation = (Operation) (operations
						.elementAt(programCounter + 1));
				for (int j = 0; j < nextOperation.getNumberOfParameter(); j++) {
					int[] inputMap = nextOperation.getInputMapForParameter(j);
					Operation sourceOperation = (Operation) operations
							.elementAt(inputMap[0]);
					Class sourceClass = sourceOperation.getClass();
					Class destClass = nextOperation.getClass();
					Class[] paramTypes = new Class[1];
					paramTypes[0] = nextOperation.getParameterTypes()[j];
					String getMethodName = sourceOperation.getResultNames()[inputMap[1]];
					Method getMethod;
					try {
						getMethod = sourceClass.getMethod(
								"get" + getMethodName, null);
						String setMethodName = nextOperation
								.getParameterNames()[j];
						Method setMethod = destClass.getMethod("set"
								+ setMethodName, paramTypes);
						Object[] input = new Object[1];
						input[0] = getMethod.invoke(sourceOperation,
								new Object[0]);
						setMethod.invoke(nextOperation, input);
						inputIndex++;
					} catch (SecurityException e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
					} catch (NoSuchMethodException e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
					} catch (IllegalArgumentException e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
					} catch (IllegalAccessException e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
					} catch (InvocationTargetException e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
					}
					Thread.yield();
				}
			}
		}
		this.setProgress(operations.size());
		if (applicationView!=null) {
			applicationView.repaint();
		}
	}
	

	/**
	 * @param i
	 */
	private void cleanupResultsAfter(int i) {
		if (i==0) return;
		Integer key = new Integer(i);
		if (!deleteAfterMap.containsKey(key)) return;
		Vector list = (Vector) deleteAfterMap.get(key);
		Iterator it = list.iterator();
		while(it.hasNext()) {
			int[] map = (int[])it.next();
			int operationNr = map[0];
			int resultNr = map[1];
			resetResult(operationNr, resultNr);
		}
		System.gc();
	}

	/**
	 * @param operationNr
	 * @param resultNr
	 */
	private void resetResult(int operationNr, int resultNr) {
		Operation operation = (Operation) (operations
				.elementAt(operationNr));
		String[] resultNames = operation.getResultNames();
			Class[] resultType = new Class[1];
			resultType[0] = operation.getResultTypes()[resultNr];
			Method setMethod;
				try {
					setMethod = operation.getClass().getMethod("set"
							+ resultNames[resultNr], resultType);
					Object[] param = new Object[1];
					param[0] = null;
					setMethod.invoke(operation, param);
				} catch (SecurityException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (NoSuchMethodException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (IllegalArgumentException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (IllegalAccessException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (InvocationTargetException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
	}

	/**
	 * 
	 */
	private void cleanUp() {
		for (int i = 0; i < operations.size(); i++) {
			Operation operation = (Operation) (operations
					.elementAt(i));
			if (operation.isLoop()) {
				operation.reset();
			}
			String[] resultNames = operation.getResultNames();
			for (int j=0; j<resultNames.length; j++) {
				resetResult(i, j);
			}
		}
		System.gc();
	}

	public void cleanupResultsAfter(Operation anOperation) {
		int startIndex = this.getOperations().indexOf(anOperation) + 1;
		for (int i = startIndex; i < operations.size(); i++) {
			Operation operation = (Operation) (operations
					.elementAt(i));
			String[] resultNames = operation.getResultNames();
			for (int j=0; j<resultNames.length; j++) {
				resetResult(i, j);
			}
		}
		System.gc();
	}
	protected void setupOptions() {
		options = new Options();
		options.setName(this.name() + " options");
		for (int i=0; i<this.operations.size(); i++){
			Operation op = (Operation) operations.elementAt(i);
			op.setApplication(this);
			Vector someOptions = op.getOptions().getOptions();
			for (int j=0; j<someOptions.size(); j++) {
				options.add((Option) someOptions.elementAt(j));
			}
		}
		this.optionsNames = new String[options.getOptions().size()];
		for (int i=0; i<options.getOptions().size(); i++) {
			this.getOptionsNames()[i] = ((Option)(options.getOptions().elementAt(i))).getName();
		}
	}
	
	public void showApplicationView() {
		ApplicationView view = this.getApplicationView();
		view.setVisible(true);
	}

	/**
	 * @return
	 */
	public ApplicationView getApplicationView() {
		if (applicationView==null) {
			applicationView = new ApplicationView(this);
			openApplicationViews.add(applicationView);
		}
		return applicationView;
	}
	/**
	 * @return Returns the input.
	 */
	public Vector getInputMaps() {
		return inputMaps;
	}
	/**
	 * @return Returns the operations.
	 */
	public Vector getOperations() {
		return operations;
	}
	
	/**
	 * @return
	 */
	public boolean isApplication() {
		// TODO Auto-generated method stub
		return true;
	}

	/**
	 * @param model
	 */
	public void showParameterViewForOperation(Operation anOperation) {
		parameter = new Parameter(anOperation, this);
		parameter.show();
	}
	
	public String name() {
		if (name==null) {
			name = "";
		}
		return name;
	}
	
	public void setName(String name) {
		this.name = name;
		this.setupOptions();
	}

	/**
	 * @param model
	 * @param e
	 */
	public static void checkForDropAction(Operation operation, MouseEvent e) {
		for (int i=0; i<openApplicationViews.size(); i++) {
			ApplicationView appView = (ApplicationView) openApplicationViews.elementAt(i);
			Rectangle viewBounds = appView.getBounds();
			Point point = e.getPoint(); 
			SwingUtilities.convertPointToScreen(point,
					e.getComponent());
			if (viewBounds.contains(point)) {
				Point localPoint = SwingUtilities.convertPoint(e.getComponent(), e.getPoint(), appView.getJPanel());
				appView.operationDropedAt(operation, localPoint);
				break;
			}
		}
		
	}

	/**
	 * @param view
	 */
	public void applicationViewClosed(ApplicationView view) {
		openApplicationViews.remove(view);
	}

	/**
	 * @param listener
	 */
	public void moveToFront(ApplicationView view) {
		openApplicationViews.remove(view);
		openApplicationViews.insertElementAt(view,0);
		
	}

	/**
	 * @param operation
	 * @param addAfterIndex
	 */
	public void addOperationAfterIndex(Operation operation, int addAfterIndex) {
		operation.setApplication(this);
		this.getOperations().add(addAfterIndex+1, operation);
		// this.resetInputStartingAtIndex(addAfterIndex+2);
		adjustInputStartingAtIndex(addAfterIndex+1, 1);
		operation.view().dispose();
		operation.setShowResult(false);
		rebuildViews();
		operation.changed("input map");
	}

	/**
	 * @param i
	 * @param j
	 */
	private void adjustInputStartingAtIndex(int index, int delta) {
		for (int i=index; i<this.getOperations().size();i++) {
			Operation operation = (Operation) this.getOperations().elementAt(i);
			Vector inputMap = operation.getInputMap();
			for (int j=0; j<inputMap.size(); j++) {
				int[] map = (int[]) inputMap.elementAt(j);
				if (map[0]==-1) continue;
				if (delta==-1 && map[0]==index) {
					map[0] = -1;
					map[1] = -1;
					inputMap.set(j, map);
					continue;
				}
				if (map[0]<index) continue;
				map[0] = map[0] + delta;
				inputMap.set(j, map);
			}
			operation.setInputMap(inputMap);
			operation.changed("input map");
		}
	}

	/**
	 * 
	 */
	private void rebuildViews() {
		if (applicationView==null) return;
		Rectangle bounds = applicationView.getBounds();
		this.applicationView.rebuild();
		applicationView.setBounds(bounds);
		this.applicationView.validate();
		this.setupOptions();
		bounds = this.view().getBounds();
		this.view().dispose();
		view = null;
		this.show();
		this.view().setBounds(bounds);
	}

	/**
	 * @param operation
	 */
	public void removeOperation(Operation operation) {
		int index = operations.indexOf(operation);
		operations.remove(operation);
		// this.resetInputStartingAtIndex(index);
		adjustInputStartingAtIndex(index, -1);
		operation.view().dispose();
		if (this.applicationView!=null) {
			this.rebuildViews();
		}
		operation.changed("input map");
	}
	
	public void printOn(BufferedWriter out) throws IOException {
		out.write(this.getClass().getName() + "\n");
		out.write(this.name() + "\n");
		Iterator it = this.getOperations().iterator();
		while(it.hasNext()) {
			Operation anOperation = (Operation)it.next();
			anOperation.printOn(out);
		}
	}
	

	/**
	 * @param in
	 * @throws IOException
	 */
	public void setupFrom(BufferedReader in) throws IOException {
		String applicationName = in.readLine();
		this.setName(applicationName);
		this.operations = new Vector();
		Operation op = null;
		while((op = Operation.readFrom(in))!=null) {
			this.operations.add(op);
		}
	}
	
	public void save(String path) throws IOException {
		FileWriter fileWriter;
		BufferedWriter out = null;
		try {
			fileWriter = new FileWriter(path);
			out = new BufferedWriter(fileWriter);
			this.printOn(out);
			this.setPath(path);
		} catch (IOException e) {
			if (out!=null) {
				try {
					out.close();
				} catch (IOException e1) {
					// ignore
				}
			}
			throw e;
		} finally {
			if (out!=null) {
				try {
					out.close();
				} catch (IOException e1) {
					// ignore
				}
			}
		}
		CellImageAnalyzer app = CellImageAnalyzer.getCurrent();
		app.rebuildApplicationMenu();
	}

	public static Application load(String path) {
		FileReader fileReader;
		BufferedReader in = null;
		Application app = null;
		try {
			fileReader = new FileReader(path);
			in = new BufferedReader(fileReader);
			app = (Application) Application.readFrom(in);
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} finally {
			if (in!=null) {
				try {
					in.close();
				} catch (IOException e1) {
					// ignore
				}
			}
		}
		app.setPath(path);
		app.setName(nameFromPath(path));
		app.setupOptions();
		return app;
	}
	
	/**
	 * @param path2
	 * @return
	 */
	public static String nameFromPath(String aPath) {
		String result;
		String separator = "/";
		if (aPath.contains("\\")) {
				separator = "\\";
		}
		int startIndex = aPath.lastIndexOf(separator) + 1;
		int endIndex = aPath.lastIndexOf(".");
		result = aPath.substring(startIndex, endIndex);
		return result;
	}

	/**
	 * @return
	 */
	public String getFilename() {
		return this.name() + fileExtension();
	}
	
	static public String fileExtension() {
		return ".cia";
	}
	
	/**
	 * @return
	 */
	public static String baseFolder() {
		return "_applications";
	}
	
	/**
	 * @return Returns the path.
	 */
	public String getPath() {
		if (path==null) {
			File file = new File("." + File.separator + baseFolder() + File.separator + this.name());
			path = file.getAbsolutePath() + fileExtension();
		}
		return path;
	}
	/**
	 * @param path The path to set.
	 */
	public void setPath(String path) {
		this.path = path;
	}
	/**
	 * @return Returns the programCounter.
	 */
	public int getProgramCounter() {
		return programCounter;
	}
	/**
	 * @param programCounter The programCounter to set.
	 */
	public void setProgramCounter(int programCounter) {
		this.programCounter = programCounter;
	}

	/**
	 * @param i
	 */
	public void backToOperationNumber(int i) {
		this.programCounter = i;
		
	}

	/**
	 * 
	 */
	public void resetPathOptions() {
		Iterator it = this.operations.iterator();
		while (it.hasNext()) {
			Operation op = (Operation) it.next();
			op.resetPathOptions();
			op.setPathOptionsFromUser();
			if (stopped) break;
		}
		
	}

	/**
	 * @param target
	 * @return
	 */
	public int indexOfNextLoopEndAfter(Operation operation) {
		int opIndex = this.operations.indexOf(operation);
		for (int i = opIndex; i<this.operations.size(); i++) {
			Operation anOperation = (Operation)this.operations.elementAt(i);
			if (anOperation.isLoopEnd()) return i;
		}
		return operations.size()-1;
	}
	
	/**
	 * @param operation
	 */
	public int getCurrentIndexInLoopFor(Operation operation) {
		int level = 0;
		int result = -1;
		int opIndex = this.operations.indexOf(operation);
		for (int i = opIndex; i>-1; i--) {
			Operation anOperation = (Operation)this.operations.elementAt(i);
			if (anOperation.isLoop() && level==0) {
				result = anOperation.getCurrentIndex();
			}
			if (anOperation.isLoopEnd()) level++;
			if (anOperation.isLoop()) level--;
		}
		return result;
	}
	
	/**
	 * @param target
	 * @return
	 */
	private boolean isInLoop(Operation target) {
		return this.getCurrentIndexInLoopFor(target) != -1;
	}

}