/*
 * Created on 30.09.2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package broadcaster;

import utils.Broadcaster;
import ij.ImagePlus;
import ij.gui.Roi;
import ij.measure.Calibration;
import ij.plugin.frame.ContrastAdjuster;
import ij.process.ImageProcessor;
import ij.process.ImageStatistics;
import imagejProxies.ContrastAdjusterProxy;

/**
 * @author Volker
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class ObservableContrastAdjuster extends ContrastAdjuster {
	/**
	 * 
	 */
	private static final long serialVersionUID = 4355826412045109601L;
	protected Broadcaster broadcaster;
	protected ContrastAdjusterProxy proxy;
	static protected ContrastAdjusterProxy staticProxy;
	
	public ObservableContrastAdjuster() {
		proxy = new ContrastAdjusterProxy(this);
		staticProxy = new ContrastAdjusterProxy(this);
	}
	
	void doUpdate() {
		proxy.doUpdate();
		this.getBroadcaster().changed("image", "updated");
	}
	/**
	 * @return Returns the broadcaster.
	 */
	public Broadcaster getBroadcaster() {
		if (broadcaster==null) {
			broadcaster = new Broadcaster();
		}
		return broadcaster;
	}
	/**
	 * @param broadcaster The broadcaster to set.
	 */
	public void setBroadcaster(Broadcaster broadcaster) {
		this.broadcaster = broadcaster;
	}
	
	static public ObservableContrastAdjuster getInstance() {
		new ObservableContrastAdjuster();
		return (ObservableContrastAdjuster) (staticProxy.getInstance());
	}
	
	public void autoAdjust(ImagePlus imp, ImageProcessor ip) {
		if (proxy.isRGBImage())
			ip.reset();
		Calibration cal = imp.getCalibration();
		imp.setCalibration(null);
		ImageStatistics stats = imp.getStatistics(); // get uncalibrated stats
		imp.setCalibration(cal);
		int[] histogram = stats.histogram;
		if (proxy.getAutoThreshold()<10)
			proxy.setAutoThreshold(proxy.getAUTO_THRESHOLD());
		else
			proxy.setAutoThreshold(proxy.getAutoThreshold() / 2);
		int threshold = stats.pixelCount/proxy.getAutoThreshold();
		int i = -1;
		boolean found = false;
		do {
			i++;
			found = histogram[i] > threshold;
		} while (!found && i<255);
		int hmin = i;
		i = 256;
		do {
			i--;
			found = histogram[i] > threshold;
		} while (!found && i>0);
		int hmax = i;
		if (hmax>=hmin) {
			imp.killRoi();
			proxy.setMin(stats.histMin+hmin*stats.binSize);
			proxy.setMax(stats.histMin+hmax*stats.binSize);
			if (proxy.getMin()==proxy.getMax())
				{proxy.setMin(stats.min); proxy.setMax(stats.max);}
			setMinAndMax(ip, proxy.getMin(), proxy.getMax());
		} else {
			proxy.reset(imp, ip);
			return;
		}
		if (proxy.getBrightnessSlider()!=null) proxy.updateScrollBars(null);
		Roi roi = imp.getRoi();
		if (roi!=null) {
			ImageProcessor mask = roi.getMask();
			if (mask!=null)
				ip.reset(mask);
		}
	}
	
	public void setMinAndMax(ImageProcessor ip, double min, double max) {
		proxy.setMinAndMax(ip, min, max);
	}

}
