/*
 * Created on 19.08.2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package channelOperations;

import gui.ChoiceOption;
import gui.Options;
import ij.ImagePlus;
import ij.ImageStack;
import ij.plugin.RGBStackMerge;
import operations.Operation;

/**
 * @author Volker
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class MergeChannelsOperation extends Operation {
	/**
	 * 
	 */
	private static final long serialVersionUID = -8554655272266991314L;
	protected ImagePlus inputImageRed;
	protected ImagePlus inputImageGreen;
	protected ImagePlus inputImageBlue;
	protected ChoiceOption redChannel;
	protected ChoiceOption greenChannel;
	protected ChoiceOption blueChannel;

	protected void initialize() throws ClassNotFoundException {
		super.initialize();
		optionsNames = new String[3];
		optionsNames[0] = "red channel";
		optionsNames[1] = "green channel";
		optionsNames[2] = "blue channel";
		parameterTypes = new Class[3];
		parameterTypes[0] = Class.forName("ij.ImagePlus");
		parameterTypes[1] = Class.forName("ij.ImagePlus");
		parameterTypes[2] = Class.forName("ij.ImagePlus");
		parameterNames = new String[3];
		parameterNames[0] = "InputImageRed";
		parameterNames[1] = "InputImageGreen";
		parameterNames[2] = "InputImageBlue";
		resultTypes = new Class[1];
		resultTypes[0] = Class.forName("ij.ImagePlus");
		resultNames = new String[1];
		resultNames[0] = "Result";
	}
	
	/**
	 *  
	 */
	public void doIt() {
		ImagePlus[] channels = new ImagePlus[3];;
		this.setupChannels(channels);
		RGBStackMerge merger = new RGBStackMerge();
		ImageStack redStack = null;
		ImageStack greenStack = null;
		ImageStack blueStack = null;
		if (channels[0]!=null) redStack = this.getInputImageRed().getStack();
		if (channels[1]!=null) greenStack = this.getInputImageGreen().getStack();
		if (channels[2]!=null) blueStack = this.getInputImageBlue().getStack();
		ImageStack mergedStacks = merger.mergeStacks(this.getInputImageRed().getWidth(),
												     this.getInputImageRed().getHeight(),
													 this.getInputImageRed().getStackSize(),
													 redStack,
													 greenStack,
													 blueStack,
													 this.keepSource);
		result = new ImagePlus("RGB", mergedStacks);
	}
	/**
	 * 
	 */
	private void setupChannels(ImagePlus[] channels) {
		channels[0] = null;
		channels[1] = null;
		channels[2] = null;
		if (this.getRedChannel().equals(this.choices()[0])) {
			channels[0] = this.getInputImageRed();
		}
		if (this.getRedChannel().equals(this.choices()[1])) {
			channels[0] = this.getInputImageGreen();
		}
		if (this.getRedChannel().equals(this.choices()[2])) {
			channels[0] = this.getInputImageBlue();
		}
		if (this.getGreenChannel().equals(this.choices()[0])) {
			channels[1] = this.getInputImageRed();
		}
		if (this.getGreenChannel().equals(this.choices()[1])) {
			channels[1] = this.getInputImageGreen();
		}
		if (this.getGreenChannel().equals(this.choices()[2])) {
			channels[1] = this.getInputImageBlue();
		}
		if (this.getBlueChannel().equals(this.choices()[0])) {
			channels[2] = this.getInputImageRed();
		}
		if (this.getBlueChannel().equals(this.choices()[1])) {
			channels[2] = this.getInputImageGreen();
		}
		if (this.getBlueChannel().equals(this.choices()[2])) {
			channels[2] = this.getInputImageBlue();
		}
	}

	/**
	 * @return Returns the inputImageBlue.
	 */
	public ImagePlus getInputImageBlue() {
		return inputImageBlue;
	}
	/**
	 * @param inputImageBlue The inputImageBlue to set.
	 */
	public void setInputImageBlue(ImagePlus inputImageBlue) {
		this.inputImageBlue = inputImageBlue;
	}
	/**
	 * @return Returns the inputImageGreen.
	 */
	public ImagePlus getInputImageGreen() {
		return inputImageGreen;
	}
	/**
	 * @param inputImageGreen The inputImageGreen to set.
	 */
	public void setInputImageGreen(ImagePlus inputImageGreen) {
		this.inputImageGreen = inputImageGreen;
	}
	/**
	 * @return Returns the inputImageRed.
	 */
	public ImagePlus getInputImageRed() {
		return inputImageRed;
	}
	/**
	 * @param inputImageRed The inputImageRed to set.
	 */
	public void setInputImageRed(ImagePlus inputImageRed) {
		this.inputImageRed = inputImageRed;
	}
	/**
	 * @return Returns the blueChannel.
	 */
	public String getBlueChannel() {
		return blueChannel.getValue();
	}
	/**
	 * @param blueChannel The blueChannel to set.
	 */
	public void setBlueChannel(String blueChannel) {
		this.blueChannel.setValue(blueChannel);
	}
	/**
	 * @return Returns the greenChannel.
	 */
	public String getGreenChannel() {
		return greenChannel.getValue();
	}
	/**
	 * @param greenChannel The greenChannel to set.
	 */
	public void setGreenChannel(String greenChannel) {
		this.greenChannel.setValue(greenChannel);
	}
	/**
	 * @return Returns the redChannel.
	 */
	public String getRedChannel() {
		return redChannel.getValue();
	}
	/**
	 * @param redChannel The redChannel to set.
	 */
	public void setRedChannel(String redChannel) {
		this.redChannel.setValue(redChannel);
	}
	
	public String[] choices() {
		String[] choices = {"red input", "green input", "blue input", "none"};
		return choices;
	}
	
	protected void setupOptions() {
		options = new Options(); 
		options.setName(this.name() + " options");
		String[] optionsNames = this.getOptionsNames();
		this.redChannel = new ChoiceOption(this.choices());
		this.redChannel.setValue(this.choices()[0]);
		this.redChannel.setName(optionsNames[0]);
		options.add(this.redChannel);
		this.greenChannel = new ChoiceOption(this.choices());
		this.greenChannel.setValue(this.choices()[1]);
		this.greenChannel.setName(optionsNames[1]);
		options.add(this.greenChannel);
		this.blueChannel = new ChoiceOption(this.choices());
		this.blueChannel.setValue(this.choices()[2]);
		this.blueChannel.setName(optionsNames[2]);
		options.add(this.blueChannel);
	}
	
	public void connectOptions() {
		redChannel = (ChoiceOption) options.getOptions().elementAt(0);
		greenChannel = (ChoiceOption) options.getOptions().elementAt(1);
		blueChannel = (ChoiceOption) options.getOptions().elementAt(2);
	}
	
	protected void cleanUpInput() {
		super.cleanUpInput();
		this.setInputImageRed(null);
		this.setInputImageGreen(null);
		this.setInputImageBlue(null);
	}
}
