/*
 * Created on 23.06.2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package channelOperations;

import operations.Operation;
import ij.ImagePlus;
import ij.WindowManager;
import ij.plugin.filter.RGBStackSplitter;

/**
 * @author Volker
 * 
 * TODO To change the template for this generated type comment go to Window -
 * Preferences - Java - Code Style - Code Templates
 */
public class SplitChannelsOperation extends Operation {

	/**
	 * 
	 */
	private static final long serialVersionUID = -3534936471252579600L;

	protected ImagePlus resultRed;

	protected ImagePlus resultGreen;

	protected ImagePlus resultBlue;
	
	protected boolean keepGreenChannel;
	
	protected boolean keepRedChannel;
	
	protected boolean keepBlueChannel;
	
	
	public SplitChannelsOperation() {
		super();
		keepRedChannel = true;
		keepGreenChannel = true;
		keepBlueChannel = true;
	}

	/**
	 * @throws ClassNotFoundException
	 *  
	 */
	protected void initialize() throws ClassNotFoundException {
		super.initialize();
		// Set parameterTypes, parameterNames and resultType
		parameterTypes = new Class[1];
		parameterTypes[0] = Class.forName("ij.ImagePlus");
		parameterNames = new String[1];
		parameterNames[0] = "InputImage";
		resultTypes = new Class[3];
		resultTypes[0] = Class.forName("ij.ImagePlus");
		resultTypes[1] = Class.forName("ij.ImagePlus");
		resultTypes[2] = Class.forName("ij.ImagePlus");
		resultNames = new String[3];
		resultNames[0] = "ResultRed";
		resultNames[1] = "ResultGreen";
		resultNames[2] = "ResultBlue";
	}

	/**
	 *  
	 */
	public void doIt() {
		ImagePlus inputImage = this.getInputImage();
		result = this.getCopyOfOrReferenceTo(inputImage, inputImage.getTitle());
		RGBStackSplitter splitter = new RGBStackSplitter();
		splitter.split(result);
		resultRed = WindowManager.getImage(result.getTitle() + " (red)");
		resultBlue = WindowManager.getImage(result.getTitle() + " (blue)");
		resultGreen = WindowManager.getImage(result.getTitle() + " (green)");
	}
	
	/**
	 * 
	 */
	protected void showResult() {
		if (this.getShowResult()) {
			if (this.keepRedChannel) {
				this.getResultRed().show();
			}
			if (this.keepGreenChannel) {
				this.getResultGreen().show();
			}
			if (this.keepBlueChannel) {
				this.getResultBlue().show();
			}
		}
	}
	
	/**
	 * @return Returns the resultBlue.
	 */
	public ImagePlus getResultBlue() {
		return resultBlue;
	}
	/**
	 * @param resultBlue The resultBlue to set.
	 */
	public void setResultBlue(ImagePlus resultBlue) {
		this.resultBlue = resultBlue;
	}
	/**
	 * @return Returns the resultGreen.
	 */
	public ImagePlus getResultGreen() {
		return resultGreen;
	}
	/**
	 * @param resultGreen The resultGreen to set.
	 */
	public void setResultGreen(ImagePlus resultGreen) {
		this.resultGreen = resultGreen;
	}
	/**
	 * @return Returns the resultRed.
	 */
	public ImagePlus getResultRed() {
		return resultRed;
	}
	/**
	 * @param resultRed The resultRed to set.
	 */
	public void setResultRed(ImagePlus resultRed) {
		this.resultRed = resultRed;
	}
	/**
	 * @return Returns the keepBlueChannel.
	 */
	public boolean isKeepBlueChannel() {
		return keepBlueChannel;
	}
	/**
	 * @param keepBlueChannel The keepBlueChannel to set.
	 */
	public void setKeepBlueChannel(boolean keepBlueChannel) {
		this.keepBlueChannel = keepBlueChannel;
	}
	/**
	 * @return Returns the keepGreenChannel.
	 */
	public boolean isKeepGreenChannel() {
		return keepGreenChannel;
	}
	/**
	 * @param keepGreenChannel The keepGreenChannel to set.
	 */
	public void setKeepGreenChannel(boolean keepGreenChannel) {
		this.keepGreenChannel = keepGreenChannel;
	}
	/**
	 * @return Returns the keepRedChannel.
	 */
	public boolean isKeepRedChannel() {
		return keepRedChannel;
	}
	/**
	 * @param keepRedChannel The keepRedChannel to set.
	 */
	public void setKeepRedChannel(boolean keepRedChannel) {
		this.keepRedChannel = keepRedChannel;
	}
}