package fileOperations;

import ij.IJ;
import ij.ImagePlus;
import ij.ImageStack;
import ij.io.FileSaver;

public class SaveAsTiffSequenceOperation extends SaveImageOperation {
	
	/**
	 * 
	 */
	private static final long serialVersionUID = -3493546943159700224L;
	
	public void doIt() {
		if (inputImage==null) return;
		inputImage = this.getInputImage();
		path = this.getPath();
		this.addPathAdditions();
		if (inputImage.getStackSize()==1)
			return;
		else {
			int extIndex = path.lastIndexOf(".");
			String newPath = path.substring(0, extIndex) + ".tif";
			this.saveAsTiffSeries(newPath);
		}
	}

	protected void saveAsTiffSeries(String path) {
		int number = 0;
		String digits = getDigits(number);
		ImageStack stack = inputImage.getStack();
		ImagePlus tmp = new ImagePlus();
		tmp.setTitle(inputImage.getTitle());
		int nSlices = stack.getSize();
		for (int i=1; i<=nSlices; i++) {
			IJ.showStatus("writing: "+i+"/"+nSlices);
			IJ.showProgress((double)i/nSlices);
			tmp.setProcessor(null, stack.getProcessor(i));
			digits = getDigits(number++);
			int extIndex = path.lastIndexOf(".");
			String aPath = path.substring(0, extIndex) + digits + ".tif";
			if (!(new FileSaver(tmp).saveAsTiff(aPath))) break;
		}
	}
	
	String getDigits(int n) {
		String digits = "00000000"+(1+n);
		return digits.substring(digits.length()-4);
	}
	
}
