/*
 * Created on 29.06.2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package fileOperations;

import java.io.File;
import java.util.Vector;

import operations.Operation;

import gui.BooleanOption;
import gui.Option;
import gui.Options;
import ij.io.FileSaver;
import ij.io.SaveDialog;

/**
 * @author Volker
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class SaveImageOperation extends Operation {
	/**
	 * 
	 */
	private static final long serialVersionUID = 1973545690357695121L;
	protected Boolean success;
	protected String path;
	protected BooleanOption useIndex;
	protected Option nameAddition;
	protected Option outputFolder;
	protected BooleanOption createInSourceFolder;
	
	public SaveImageOperation() {
		super();
		success = new Boolean(true);
	}
	
	/**
	 * @throws ClassNotFoundException
	 * 
	 */
	protected void initialize() throws ClassNotFoundException {	
		super.initialize();
		// Set parameterTypes, parameterNames and resultType
		parameterTypes = new Class[2];
		parameterTypes[0] = Class.forName("ij.ImagePlus");
		parameterTypes[1] = Class.forName("java.lang.String");
		parameterNames = new String[2];
		parameterNames[0] = "InputImage";
		parameterNames[1] = "Path";
		optionsNames = new String[4];
		optionsNames[0] = "output folder";
		optionsNames[1] = "create in source folder";
		optionsNames[2] = "name addition";
		optionsNames[3] = "add loop index to name";
		resultTypes = new Class[1];
		resultTypes[0] = Class.forName("java.lang.Boolean");
		resultNames = new String[1];
		resultNames[0] = "Success";
	}
	
	public void doIt() {
		if (inputImage==null) return;
		inputImage = this.getInputImage();
		FileSaver saver = new FileSaver(inputImage);
		path = this.getPath();
		this.addPathAdditions();
		if (inputImage.getStackSize()==1)
			saver.saveAsTiff(path);
		else {
			int extIndex = path.lastIndexOf(".");
			String newPath = path.substring(0, extIndex) + ".tif";
			saver.saveAsTiffStack(newPath);
		}
	}
	/**
	 * 
	 */
	public void getPathFromUser() {
		//FileSaver fileSaver = new FileSaver(inputImage);
		//path = fileSaver.getPath("TIFF", ".tif");
		name = inputImage.getTitle();
		SaveDialog sd = new SaveDialog("Save as "+"TIFF", name, ".tif");
		name = sd.getFileName();
		if (name==null)
			return;
		String directory = sd.getDirectory();
		inputImage.startTiming();
		path = directory+name;		
	}

	/**
	 * @return Returns the path.
	 */
	public String getPath() {
		if (path == null) {
			this.getPathFromUser();
			return path;
		}
		if (this.getOutputFolder()=="") {
			return path;
		}
		if (this.getOutputFolder()!="" && !this.getCreateInSourceFolder()) {
			String result = this.getOutputFolder();
			result = result + path.substring(path.lastIndexOf(File.separator), path.length());
			path = result;
			return path;
		}
		if (this.getCreateInSourceFolder()) {
			String result = path.substring(0, path.lastIndexOf(File.separator)+1);
			result = result + this.getOutputFolder().substring(this.getOutputFolder().lastIndexOf(File.separator) + 1, this.getOutputFolder().length());
			File aFile = new File(result);
			if (!aFile.exists()) aFile.mkdir();
			result = result + path.substring(path.lastIndexOf(File.separator), path.length());
			path = result;
			return path;
		} 
		return path;
	}
	/**
	 * 
	 */
	 void addPathAdditions() {
		if (this.getNameAddition()!="") {
			String ext = path.substring(path.lastIndexOf(".")+1, path.length());
			String filePath = path.substring(0,path.lastIndexOf("."));
			path = filePath + this.getNameAddition() + "." + ext;
		}
		if (this.getUseIndex()) {
			String ext = path.substring(path.lastIndexOf(".")+1, path.length());
			String filePath = path.substring(0,path.lastIndexOf("."));
			path = filePath + this.getIndex() + "." + ext;
		}
	}

	/**
	 * @return
	 */
	protected String getIndex() {
		int result = this.application.getCurrentIndexInLoopFor(this) + 1;
		return Integer.toString(result);
	}

	/**
	 * @param path The path to set.
	 */
	public void setPath(String path) {
		this.path = path;
	}
	/**
	 * @return Returns the success.
	 */
	public boolean isSuccess() {
		return success.booleanValue();
	}
	
	/**
	 * @return
	 */
	public Vector categories() {
		Vector categories = new Vector();
		categories.add("Input / Output");
		return categories;
	}
	
	/**
	 * 
	 */
	protected void cleanUpInput() {
		super.cleanUpInput();
		this.setPath(null);
	}

	/**
	 * 
	 */
	protected void showResult() {
		/** TODO show that operation finished with success or error*/
	}
	
	protected void setupOptions() {
		options = new Options(); 
		options.setName(this.name() + " options");
		String[] optionsNames = this.getOptionsNames();
		this.outputFolder = new Option();
		this.setOutputFolder("");
		this.outputFolder.setName(optionsNames[0]);
		this.outputFolder.beForFilename();
		options.add(this.outputFolder);
		this.createInSourceFolder = new BooleanOption();
		createInSourceFolder.setValue("false");
		createInSourceFolder.setName(optionsNames[1]);
		options.add(createInSourceFolder);
		nameAddition = new Option();
		nameAddition.setValue("");
		nameAddition.setName(optionsNames[2]);
		options.add(nameAddition);
		useIndex = new BooleanOption();
		useIndex.setValue(Boolean.toString(false));
		useIndex.setName(optionsNames[3]);
		options.add(useIndex);
	}
	
	/**
	 * @param property
	 */
	public void setOutputFolder(String path) {
		this.outputFolder.setValue(path);
		
	}

	public void connectOptions() {
		this.outputFolder = (Option) this.options.getOptions().elementAt(0);
		this.outputFolder.beForFilename();
		this.createInSourceFolder = (BooleanOption) this.options.getOptions().elementAt(1);
		this.nameAddition = (Option) this.options.getOptions().elementAt(2);
		this.useIndex = (BooleanOption) this.options.getOptions().elementAt(3);
	}
	/**
	 * @return Returns the createInSourceFolder.
	 */
	public boolean getCreateInSourceFolder() {
		return createInSourceFolder.getBooleanValue();
	}
	/**
	 * @param createInSourceFolder The createInSourceFolder to set.
	 */
	public void setCreateInSourceFolder(boolean value) {
		this.createInSourceFolder.setValue(new Boolean(value).toString());
	}
	/**
	 * @return Returns the outputFolder.
	 */
	public String getOutputFolder() {
		return outputFolder.getValue();
	}
	/**
	 * @return Returns the success.
	 */
	public Boolean getSuccess() {
		return success;
	}
	/**
	 * @param success The success to set.
	 */
	public void setSuccess(Boolean success) {
		this.success = success;
	}
	/**
	 * @return Returns the nameAddition.
	 */
	public String getNameAddition() {
		return nameAddition.getValue();
	}
	/**
	 * @param nameAddition The nameAddition to set.
	 */
	public void setNameAddition(String nameAddition) {
		this.nameAddition.setValue(nameAddition);
	}
	/**
	 * @return Returns the useIndex.
	 */
	public boolean getUseIndex() {
		return useIndex.getBooleanValue();
	}
	/**
	 * @param useIndex The useIndex to set.
	 */
	public void setUseIndex(boolean useIndex) {
		this.useIndex.setValue(Boolean.toString(useIndex));
	}
}
