package gui;

import java.awt.BorderLayout;
import java.util.Observable;
import java.util.Observer;

import javax.swing.JPanel;
import javax.swing.JFrame;
import javax.swing.BoxLayout;
import javax.swing.JButton;

public class MultiChannelListEditorView extends JFrame implements Observer {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private JPanel jContentPane = null;
	private JPanel editorPanel = null;
	private JPanel buttonPanel = null;
	private JButton closeButton = null;
	private JButton addChannelButton = null;
	private MultiChannelListEditor model;

	/**
	 * This is the default constructor
	 */
	public MultiChannelListEditorView() {
		super();
		initialize();
	}

	public MultiChannelListEditorView(MultiChannelListEditor editor) {
		super();
		this.model = editor;
		model.addObserver(this);
		initialize();
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		this.setSize(396, 291);
		this.setContentPane(getJContentPane());
		this.setTitle("Multi Channel List Editor");
	}

	/**
	 * This method initializes jContentPane
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJContentPane() {
		if (jContentPane == null) {
			jContentPane = new JPanel();
			jContentPane.setLayout(new BorderLayout());
			jContentPane.add(getEditorPanel(), java.awt.BorderLayout.NORTH);
			jContentPane.add(getButtonPanel(), java.awt.BorderLayout.SOUTH);
		}
		return jContentPane;
	}

	public void update(Observable arg0, Object arg1) {
		// TODO Auto-generated method stub
		
	}

	/**
	 * This method initializes editorPanel	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getEditorPanel() {
		if (editorPanel == null) {
			editorPanel = new JPanel();
			editorPanel.setLayout(new BoxLayout(getEditorPanel(), BoxLayout.Y_AXIS));
		}
		return editorPanel;
	}

	/**
	 * This method initializes buttonPanel	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getButtonPanel() {
		if (buttonPanel == null) {
			buttonPanel = new JPanel();
			buttonPanel.setLayout(null);
			buttonPanel.setPreferredSize(new java.awt.Dimension(30,30));
			buttonPanel.add(getAddChannelButton(), null);
			buttonPanel.add(getCloseButton(), null);
		}
		return buttonPanel;
	}

	/**
	 * This method initializes closeButton	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getCloseButton() {
		if (closeButton == null) {
			closeButton = new JButton();
			closeButton.setBounds(new java.awt.Rectangle(245,4,122,20));
			closeButton.setText("close");
		}
		return closeButton;
	}

	/**
	 * This method initializes addChannelButton	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getAddChannelButton() {
		if (addChannelButton == null) {
			addChannelButton = new JButton();
			addChannelButton.setBounds(new java.awt.Rectangle(7,4,122,20));
			addChannelButton.setText("add channel");
		}
		return addChannelButton;
	}

}  //  @jve:decl-index=0:visual-constraint="10,10"
