package gui;

import ij.IJ;
import ij.ImagePlus;

import java.util.Observable;
import java.util.Vector;

import stack.MeasureStack;

public class ObjectExtractor3D extends Observable {
	protected MeasureStack stackMeasurer;
	protected ImagePlus inputImage;
	protected ImagePlus sceneImage;
	protected Vector objects;
	
	protected ObjectExtractor3DView view;
	public ObjectExtractor3D() {
		super();
	}
	
	protected ObjectExtractor3DView getView() {
		if (this.view==null) this.view = new ObjectExtractor3DView(this);
		return this.view;
	}
	
	public void show() {
		this.getView().setVisible(true);
	}

	public ImagePlus getInputImage() {
		return inputImage;
	}

	public void setInputImage(ImagePlus inputImage) {
		this.inputImage = inputImage;
	}

	public ImagePlus getSceneImage() {
		return sceneImage;
	}

	public void setSceneImage(ImagePlus sceneImage) {
		this.sceneImage = sceneImage;
	}

	public void openStack() {
		IJ.run("Open...");
		this.getActiveStack();
	}
	
	public void getActiveStack() {
		this.setInputImage(IJ.getImage());
		if (stackMeasurer != null) stackMeasurer.dispose();
		if (stackMeasurer == null) {
			stackMeasurer = new MeasureStack(this.getInputImage());	
		}
	}

	public Vector getObjects() {
		return objects;
	}

	public void setObjects(Vector objects) {
		this.objects = objects;
	}
}
