/*
 * Created on 19.10.2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package guiOperations;

import ij.gui.ImageCanvas;
import ij.gui.ImageWindow;

import java.awt.Point;

import gui.BooleanOption;
import gui.Option;
import gui.Options;
import operations.Operation;

/**
 * @author Volker
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class ZoomViewOperation extends Operation {
	/**
	 * 
	 */
	private static final long serialVersionUID = 7150080905726066665L;
	
	protected BooleanOption zoomIn;
	protected Option times;
	
	protected void initialize() throws ClassNotFoundException {
		super.initialize();
		// Set parameterTypes, parameterNames and resultType
		parameterTypes = new Class[1];
		parameterTypes[0] = Class.forName("ij.ImagePlus");
		parameterNames = new String[1];
		parameterNames[0] = "InputImage";
		optionsNames = new String[2];
		optionsNames[0] = "zoom in";
		optionsNames[1] = "times";
		resultTypes = new Class[0];
		resultNames = new String[0];
	}
	
	public void doIt() {
		for (int i=0; i<this.getTimes(); i++) {
			ImageWindow win = inputImage.getWindow();
			if (win==null) return;
			ImageCanvas ic = win.getCanvas();
			Point loc = ic.getCursorLoc();
			int x = ic.screenX(loc.x);
			int y = ic.screenY(loc.y);
			if (this.getZoomIn()) {
				ic.zoomIn(x, y);
				if (ic.getMagnification()<=1.0) inputImage.repaintWindow();
			} else {
				ic.zoomOut(x, y);
				if (ic.getMagnification()<1.0) inputImage.repaintWindow();
			}
		}
	}
	
	protected void setupOptions() {
		options = new Options(); 
		options.setName(this.name() + " options");
		this.zoomIn = new BooleanOption();
		this.zoomIn.setName(optionsNames[0]);
		this.setZoomIn(false);
		zoomIn.setShortHelpText("select to zoom in and deselect to zoom out");
		options.add(zoomIn);
		this.times = new Option();
		this.times.setName(optionsNames[1]);
		this.setTimes(1);
		times.setShortHelpText("enter the number of times to zoom in or out");
		options.add(times);
	}
	
	public void connectOptions() {
		this.zoomIn = (BooleanOption) this.options.getOptions().elementAt(0);
		this.times = (Option) this.options.getOptions().elementAt(1);
	}
	/**
	 * @return Returns the times.
	 */
	public int getTimes() {
		return times.getIntegerValue();
	}
	/**
	 * @param times The times to set.
	 */
	public void setTimes(int times) {
		this.times.setValue(Integer.toString(times));
	}
	/**
	 * @return Returns the zoomIn.
	 */
	public boolean getZoomIn() {
		return zoomIn.getBooleanValue();
	}
	/**
	 * @param zoomIn The zoomIn to set.
	 */
	public void setZoomIn(boolean zoomIn) {
		this.zoomIn.setValue(Boolean.toString(zoomIn));
	}
}
