package imageOperations;

import ij.IJ;
import gui.BooleanOption;
import gui.Option;
import gui.Options;
import operations.FilterOperation;

public class ResizeToRotateOperation extends FilterOperation {
	protected Option fillBlack;
	/**
	 * 
	 */
	private static final long serialVersionUID = -8152233029043810901L;
	
	protected void initialize() throws ClassNotFoundException {
		super.initialize();
		optionsNames = new String[1];
		optionsNames[0] = "fill black";
	}
	
	protected void setupOptions() {
		options = new Options(); 
		options.setName(this.name() + " options");
		String[] optionsNames = this.getOptionsNames();
		this.fillBlack = new BooleanOption();
		this.fillBlack.setValue("true");
		this.fillBlack.setName(optionsNames[0]);
		this.fillBlack.setShortHelpText("if selected the enlarged area will be black, otherwise it will be white");
		options.add(this.fillBlack);
	}
	
	public void connectOptions() {
		fillBlack = (BooleanOption) options.getOptions().elementAt(0);
	}

	public boolean getFillBlack() {
		return fillBlack.getBooleanValue();
	}

	public void setFillBlack(boolean fillBlack) {
		this.fillBlack.setValue(Boolean.toString(fillBlack));
	}
	
	public void runFilter() {
		int x = result.getWidth();
		int y = result.getHeight();
		double d = 2+Math.sqrt(x*x+y*y);
		if (this.getFillBlack()) {
			IJ.run("Canvas Size...", "width="+d + " height="+d+ " position=Center zero");
		} else {
			IJ.run("Canvas Size...", "width="+d + " height="+d+ " position=Center");
		}
	}
}
