package imagejProxies;

/*
 * Created on 13.10.2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */

import ij.IJ;
import ij.ImagePlus;
import ij.plugin.ImageCalculator;

/**
 * @author Volker
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class SilentImageCalculator extends ImageCalculator {
	protected int operator;
	protected boolean createWindow = true;
	protected boolean floatResult;
	protected ImageCalculatorProxy proxy;
	
	public SilentImageCalculator() {
		proxy = new ImageCalculatorProxy(this);
	}
	
	public void run(ImagePlus img1, ImagePlus img2) {
		IJ.register(ImageCalculator.class);
		if (img1.getCalibration().isSigned16Bit() || img2.getCalibration().isSigned16Bit())
			floatResult = true;
		if (floatResult)
			createWindow = true;
		int size1 = img1.getStackSize();
		int size2 = img2.getStackSize();
		if (size1>1 && size2>1 && size1!=size2) {
			IJ.error("Image Calculator", "Both stacks must have the same number of slices.");
			return;
		}
		boolean tmpCreateWindow = proxy.isCreateWindow();
		boolean tmpFloatResult = proxy.isFloatResult();
		int tmpOperator = proxy.getOperator();
		proxy.setCreateWindow(this.isCreateWindow());
		proxy.setFloatResult(this.isFloatResult());
		proxy.setOperator(this.getOperator());
		if (size1>1 && (size2==1||size1==size2)) {
			proxy.doStackOperation(img1, img2);
		} else
			proxy.doOperation(img1, img2);
		proxy.setCreateWindow(tmpCreateWindow);
		proxy.setFloatResult(tmpFloatResult);
		proxy.setOperator(tmpOperator);
	}
	/**
	 * @return Returns the createWindow.
	 */
	public boolean isCreateWindow() {
		return createWindow;
	}
	/**
	 * @param createWindow The createWindow to set.
	 */
	public void setCreateWindow(boolean createWindow) {
		this.createWindow = createWindow;
	}
	/**
	 * @return Returns the floatResult.
	 */
	public boolean isFloatResult() {
		return floatResult;
	}
	/**
	 * @param floatResult The floatResult to set.
	 */
	public void setFloatResult(boolean floatResult) {
		this.floatResult = floatResult;
	}
	/**
	 * @return Returns the operator.
	 */
	public int getOperator() {
		return operator;
	}
	/**
	 * @param operator The operator to set.
	 */
	public void setOperator(int operator) {
		this.operator = operator;
	}
}
