package imagejProxies;

/*
 * Created on 17.10.2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */

import ij.IJ;
import ij.ImagePlus;
import ij.WindowManager;
import ij.gui.HistogramWindow;
import ij.measure.ResultsTable;
import ij.plugin.filter.Analyzer;
import ij.plugin.filter.ParticleAnalyzer;
import ij.process.FloatProcessor;
import ij.process.ImageProcessor;

/**
 * @author Volker
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class SilentParticleAnalyzer extends ParticleAnalyzer {
	protected ImagePlus outlinesImage;
	protected ParticleAnalyzerProxy proxy;
	protected AnalyzerProxy analyzerProxy;
	
	public SilentParticleAnalyzer(int options, int measurements, ResultsTable rt, double minSize, double maxSize) {
		super(options, measurements, rt, minSize, maxSize);
		proxy = new ParticleAnalyzerProxy(this);
		analyzerProxy = new AnalyzerProxy(new SilentAnalyzer());
	}	
	
	public boolean analyze(ImagePlus imp, ImageProcessor ip) {
		boolean result = super.analyze(imp, ip);
	//	ImagePlus currentImage = WindowManager.getCurrentImage();
	//	if (currentImage!=null) currentImage.hide();
		this.showResults();
		return result;
	}
	
	protected void showResults() {
		int count = rt.getCounter();
		if (count==0)
			return;
		boolean lastSlice = !processStack||slice==imp.getStackSize();
		if (displaySummary && lastSlice && rt==Analyzer.getResultsTable() && imp!=null) {
			proxy.showSummary();
		}
		if (showSizeDistribution && lastSlice) {
			float[] areas = rt.getColumn(ResultsTable.AREA);
			if (areas!=null) {
				ImageProcessor ip = new FloatProcessor(count, 1, areas, null);
				new HistogramWindow("Particle Size Distribution", new ImagePlus("",ip), proxy.getSizeBins());
			}
		}
		if (proxy.getOutlines()!=null && lastSlice) {
			String title = imp!=null?imp.getTitle():"Outlines";
			String prefix = showChoice==MASKS?"Mask of ":"Drawing of ";
			outlinesImage = new ImagePlus(prefix+title, proxy.getOutlines());
		}
		if (showResults && !processStack) {
			analyzerProxy.setFirstParticle(proxy.getBeginningCount());
			analyzerProxy.setLastParticle(Analyzer.getCounter()-1);
		} else {
			analyzerProxy.setFirstParticle(0);
			analyzerProxy.setLastParticle(0);
		}
	}
	
	
	/**
	 * @return Returns the outlineImage.
	 */
	public ImagePlus getOutlineImage() {
		return outlinesImage;
	}
	
	public static int getShowChoice() {
		return showChoice;
	}
	
	public static void setShowChoice(int newChoice) {
		showChoice = newChoice;
	}
	
	public void setRedirectTarget(int index) {
		analyzerProxy.setRedirectTarget(index);
	}
	
	public void setRedirectTitle(String title) {
		analyzerProxy.setRedirectTitle(title);
	}
	
	public int getRedirectTarget() {
		return analyzerProxy.getRedirectTarget();
	}
	
	public String getRedirectTitle() {
		return analyzerProxy.getRedirectTitle();
	}
}
