/*
 * Created on 31.08.2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package neuronJNewGUI;

import ij.IJ;
import ij.WindowManager;

import java.awt.Component;
import java.io.File;
import java.util.Observable;
import java.util.Observer;

import broadcaster.ObservableContrastAdjuster;

import neuronJgui.NJ;

/**
 * @author Volker
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class NeuronJ implements Observer {
	protected NeuronJView view;
	protected Component statusBar;
	protected Component toolbar; 
	protected SlideShowControl slideShowControl;
	
	public NeuronJ() {
		super();
		this.initialize();
		NJ.changeBroadcaster.addObserver(this);
		ObservableContrastAdjuster adjuster = ObservableContrastAdjuster.getInstance();
		if (adjuster!=null) {
			adjuster.getBroadcaster().addObserver(NJ.ntb);
		}
	}
	
	/**
	 * 
	 */
	private void initialize() {
		slideShowControl = new SlideShowControl();
		slideShowControl.setLoadUsingNeuronJ(true);
		NJ.autosave = true;
	}
	
	public void show() {
		this.getView().setVisible(true);
	}
	/**
	 * @return Returns the view.
	 */
	public NeuronJView getView() {
		if (view==null) {
			view = new NeuronJView(this);
		}
		return view;
	}
	/**
	 * @param view The view to set.
	 */
	public void setView(NeuronJView view) {
		this.view = view;
	}
	/**
	 * @return
	 */
	public Component getToolbar() {
		if (toolbar == null) {
			toolbar = NJ.ntb;
		}
		return toolbar;
	}
	/**
	 * @return
	 */
	public Component getStatusBar() {
		if (statusBar==null) {
			statusBar = IJ.getInstance().getComponent(0);
		}
		return statusBar;
	}
	/* (non-Javadoc)
	 * @see java.util.Observer#update(java.util.Observable, java.lang.Object)
	 */
	public void update(Observable sender, Object aspect) {
		String[] aspectDescription = ((String) aspect).split(":");
		String theAspect = aspectDescription[0];
		String newValue = aspectDescription[1];
		if (theAspect.equals("application") && newValue.equals("closed")) {
			if (statusBar==null) return;
			this.restoreImageJ();
			slideShowControl.setLoadUsingNeuronJ(false);
			this.getView().dispose();
		}
		if (theAspect.equals("image") && newValue.equals("loaded")) {
			slideShowControl.setCurrentFolder(new File(NJ.workdir));
			File inFile = new File(NJ.workdir + File.separator + IJ.getImage().getOriginalFileInfo().fileName);
			slideShowControl.setCurrentFile(inFile);
			slideShowControl.lastOpened = WindowManager.getCurrentWindow();
			if (!this.slideShowControl.getView().isShowing()) {
				this.slideShowControl.show();
			}
		}
	}
	/**
	 * 
	 */
	public void exit() {
		this.restoreImageJ();
		slideShowControl.setLoadUsingNeuronJ(false);
		NJ.quit();
	}
	/**
	 * 
	 */
	private void restoreImageJ() {
		NJ.changeBroadcaster.deleteObserver(this);
		System.out.println("restoring imageJ");
		IJ.getInstance().add(this.getToolbar());
		IJ.getInstance().add(this.getStatusBar());
		IJ.getInstance().validate();
		statusBar = null;
		toolbar = null;
	}
}
