//**********************************************************************
//COPYRIGHT NOTICE AND DISCLAIMER
//
//Copyright (c) Erik Meijering. All rights reserved.
//
//Permission to copy and use this software and accompanying
//documentation for educational, research, and not-for-profit
//purposes, without fee and without a signed licensing agreement,
//is hereby granted, provided that the above copyright notice, this
//paragraph and the following two paragraphs appear in all copies.
//The copyright holder is free to make upgraded or improved versions
//of the software available for a fee or commercially only.
//
//IN NO EVENT SHALL THE COPYRIGHT HOLDER BE LIABLE TO ANY PARTY FOR
//DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES,
//OF ANY KIND WHATSOEVER, ARISING OUT OF THE USE OF THIS SOFTWARE
//AND ITS DOCUMENTATION, EVEN IF HE HAS BEEN ADVISED OF THE
//POSSIBILITY OF SUCH DAMAGE.
//
//THE COPYRIGHT HOLDER SPECIFICALLY DISCLAIMS ANY WARRANTIES,
//INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
//MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. THE
//SOFTWARE AND ACCOMPANYING DOCUMENTATION IS PROVIDED "AS IS".
//THE COPYRIGHT HOLDER HAS NO OBLIGATION TO PROVIDE MAINTENANCE,
//SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS.
//
//**********************************************************************
package neuronJgui;

import ij.gui.ImageCanvas;

import java.awt.Graphics;

public final class Tracings {
    
    private int iCapacity = 20;
    private final int iCapInc = 20;
    private int iSize = 0;
    private Tracing[] tarray = new Tracing[iCapacity];
    
    void add(final Tracing tracing) {
	if (iSize == iCapacity) inccap();
	tarray[iSize++] = tracing;
	NJ.save = true;
    }
    
    private void inccap() {
	iCapacity += iCapInc;
	final Tracing[] newarray = new Tracing[iCapacity];
	for (int i=0; i<iSize; ++i) newarray[i] = tarray[i];
	tarray = newarray;
    }
    
    Tracing element(final int index) { return tarray[index]; }
    
    void remove(final int index) {
	for (int i1=index, i2=index+1; i2<iSize; ++i1, ++i2)
	    tarray[i1] = tarray[i2];
	--iSize;
	NJ.save = true;
    }
    
    void reset() { iSize = 0; NJ.save = true; }
    
    int nrtracings() { return iSize; }
    
    boolean changed() {
	for (int w=0; w<iSize; ++w)
	    if (tarray[w].changed()) return true;
	return false;
    }
    
    void draw(final Graphics g, final ImageCanvas imc) {
	for (int w=0; w<iSize; ++w) tarray[w].draw(g,imc);
    }

}
