/*
 * Created on 12.07.2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package operations;

import gui.LineProcessor;
import gui.Option;
import ij.gui.NewImage;

import java.awt.geom.Line2D;
import java.awt.geom.Point2D;
import java.util.Vector;

/**
 * @author Volker
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class CutLinesToSizeOperation extends Operation {
	/**
	 * 
	 */
	private static final long serialVersionUID = 3955988323282636540L;
	
	Vector lines;
	Option minConnected;
	Option gapFactor;
	Option threshold;
	Vector resultLines;

	public CutLinesToSizeOperation() {
		super();
		resultLines = new Vector();
	}
	
	protected void initialize() throws ClassNotFoundException {
		super.initialize();
		parameterTypes = new Class[2];
		parameterTypes[0] = Class.forName("ij.ImagePlus");
		parameterTypes[1] = Class.forName("java.util.Vector");
		parameterNames = new String[2];
		parameterNames[0] = "InputImage";
		parameterNames[1] = "Lines";
		optionsNames = new String[3];
		optionsNames[0] = "min connected";
		optionsNames[1] = "gap factor";
		optionsNames[2] = "threshold";
		resultTypes = new Class[2];
		resultTypes[0] = Class.forName("ij.ImagePlus");
		resultTypes[1] = Class.forName("java.util.Vector");
		resultNames = new String[2];
		resultNames[0] = "Result";
		resultNames[1] = "ResultLines";
		
	}
	
	/**
	 * @return Returns the resultLines.
	 */
	public Vector getResultLines() {
		return resultLines;
	}
	/**
	 * @param resultLines The resultLines to set.
	 */
	public void setResultLines(Vector resultLines) {
		this.resultLines = resultLines;
	}
	
	/**
	 * @return Returns the gapFactor.
	 */
	public double getGapFactor() {
		return gapFactor.getDoubleValue();
	}
	/**
	 * @param gapFactor The gapFactor to set.
	 */
	public void setGapFactor(double gapFactor) {
		this.gapFactor.setValue(new Double(gapFactor).toString());
	}
	/**
	 * @return Returns the gapFactor.
	 */
	public double getThreshold() {
		return threshold.getDoubleValue();
	}
	
	/**
	 * @param gapFactor The gapFactor to set.
	 */
	public void setThreshold(double threshold) {
		this.threshold.setValue(new Double(threshold).toString());
	}
	/**
	 * @return Returns the minConnected.
	 */
	public int getMinConnected() {
		return minConnected.getIntegerValue();
	}
	/**
	 * @param minConnected The minConnected to set.
	 */
	public void setMinConnected(int minConnected) {
		this.minConnected.setValue(new Integer(minConnected).toString());
	}
	/**
	 * @return Returns the lines.
	 */
	public Vector getLines() {
		return lines;
	}
	/**
	 * @param lines The lines to set.
	 */
	public void setLines(Vector lines) {
		this.lines = lines;
	}
	
	protected void setupOptions() {
		super.setupOptions();
		this.setMinConnected(3);
		this.setGapFactor(1.5);
		this.setThreshold(13);
	}
	
	public void connectOptions() {
		this.minConnected = (Option) this.options.getOptions().elementAt(0);
		this.gapFactor = (Option) this.options.getOptions().elementAt(1);
		this.threshold = (Option) this.options.getOptions().elementAt(2);
	}
	
	public void doIt() {
		result = NewImage.createByteImage(inputImage.getTitle(), inputImage.getWidth(), inputImage.getHeight(), 
				inputImage.getStackSize(), NewImage.GRAY8);
		resultLines = new Vector();
		for (int i=0; i<this.lines.size(); i++) {
			Line2D aLine = (Line2D) lines.elementAt(i);
			this.cutLineToSize(aLine);
		}
		this.drawLines();
	}

	/**
	 * 
	 */
	private void drawLines() {
		for (int i=0; i<resultLines.size();i++) {
			Line2D aLine = (Line2D) resultLines.elementAt(i);
			result.getProcessor().drawLine((int)Math.round(aLine.getX1()), 
										   (int)Math.round(aLine.getY1()), 
										   (int)Math.round(aLine.getX2()), 
										   (int)Math.round(aLine.getY2()));
		}
		
	}
	/**
	 * @param line
	 */
	private void cutLineToSize(Line2D line) {
		Vector whiteSegments = new Vector();
		Point2D currentPoint = line.getP1();
		boolean lastWasWhite = false;
		Point2D start = null;
		if (this.isAboveThreshold(currentPoint, line)) {
			lastWasWhite = true;
			start = new Point2D.Double(currentPoint.getX(),currentPoint.getY());
		}
		Point2D lastPoint = new Point2D.Double(currentPoint.getX(), currentPoint.getY());
		boolean finishedSegment = true;
		while(LineProcessor.movePointAlongLine(currentPoint, line)) {
			if (this.isAboveThreshold(currentPoint, line)){
				if (!lastWasWhite) {
					start = new Point2D.Double(currentPoint.getX(),currentPoint.getY());
					finishedSegment = false;
				}
				lastWasWhite = true;
			} else {
				if (lastWasWhite) {
					whiteSegments.add(new Line2D.Float(start, lastPoint));
					finishedSegment = true;
				}
				lastWasWhite = false;
			}
			lastPoint = new Point2D.Double(currentPoint.getX(), currentPoint.getY());
		}
		if (!finishedSegment) {
			whiteSegments.add(new Line2D.Float(start, lastPoint));
		}
		if (whiteSegments.size()==1) {
			resultLines.add(whiteSegments.elementAt(0));
			return;
		}
		Vector resultSegments = whiteSegments;
		for (int i=0; i<1; i++) {
			if (resultSegments.size()==1) break;
			resultSegments = mergeAllConnected(resultSegments);
		}
			if (resultSegments.size()>0) {
			resultLines.add(new Line2D.Float(((Line2D)resultSegments.elementAt(0)).getP1(), 
											 ((Line2D)resultSegments.elementAt(resultSegments.size()-1)).getP2()));
			}
	}

	/**
	 * @param whiteSegments
	 * @return
	 */
	private Vector mergeAllConnected(Vector whiteSegments) {
		boolean[] connected = new boolean[whiteSegments.size()-1];
		// todo: search all connected regions
		// find start and end as start and end of longest connected region
		for (int i=0; i<whiteSegments.size()-1; i++) {
			Line2D aSegment = (Line2D) whiteSegments.elementAt(i);
			Line2D nextSegment = (Line2D) whiteSegments.elementAt(i+1);
			double length = aSegment.getP1().distance(aSegment.getP2());
			double gapLength = aSegment.getP2().distance(nextSegment.getP1());
			if ((length >= minConnected.getDoubleValue()) && (gapLength<=(gapFactor.getDoubleValue()*length))) {
				connected[i] = true;
			} else {
				connected[i] = false;
			}
		}
		Vector resultSegments = this.mergeConnected(whiteSegments, connected);
		return resultSegments;
	}

	/**
	 * @param whiteSegments
	 * @param connected
	 * @return
	 */
	private Vector mergeConnected(Vector whiteSegments, boolean[] connected) {
		Vector result = new Vector();
		Point2D start = ((Line2D)(whiteSegments.elementAt(0))).getP1();
		Point2D end = ((Line2D)(whiteSegments.elementAt(0))).getP2();
		for (int i=0; i<connected.length;i++) {
			if (connected[i]) {
				end = ((Line2D)(whiteSegments.elementAt(i+1))).getP2();
				if (i==connected.length-1) {
					result.add(new Line2D.Float(start,end));
				}
			} else {
				if (!(i==0 || !connected[i-1])) { 
				 result.add(new Line2D.Float(start,end));
				}
				start = ((Line2D)(whiteSegments.elementAt(i+1))).getP1();
				end = ((Line2D)(whiteSegments.elementAt(i+1))).getP2();
			}
		}
		return result;
	}

	/**
	 * @param currentPoint
	 * @param line
	 * @return
	 */
	private boolean isAboveThreshold(Point2D currentPoint, Line2D line) {
		Line2D perpendicularSegment = LineProcessor.perpendicularLine(new Line2D.Float(currentPoint, line.getP2()), 6);
		double[] pixelValues = inputImage.getProcessor().getLine(perpendicularSegment.getX1(), 
																 perpendicularSegment.getY1(), 
																 perpendicularSegment.getX2(), 
																 perpendicularSegment.getY2());
		for (int i=0; i<pixelValues.length; i++) {
			if(pixelValues[i]>threshold.getDoubleValue()) return true;
		}
		return false;
	}
	
	protected void cleanUpInput() {
		super.cleanUpInput();
		this.setLines(null);
	}
}
