/*
 * Created on 27.06.2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package operations;

import gui.Option;
import ij.ImagePlus;
import ij.gui.NewImage;
import ij.measure.ResultsTable;

import java.awt.Point;
import java.awt.geom.Line2D;
import java.awt.geom.Point2D;
import java.util.Vector;

import analysisOperations.FindObjectsOperation;

/**
 * @author Volker
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class FindStraightLinesOperation extends Operation {
	
	/**
	 * 
	 */
	private static final long serialVersionUID = -7249406727483686387L;
	
	protected ResultsTable centroids;
	protected Option minLength;
	protected Option minMeanGreyLevel;

	protected void initialize() throws ClassNotFoundException {
		super.initialize();
		parameterTypes = new Class[2];
		parameterTypes[0] = Class.forName("ij.ImagePlus");
		parameterTypes[1] = Class.forName("ij.measure.ResultsTable");
		parameterNames = new String[2];
		parameterNames[0] = "InputImage";
		parameterNames[1] = "Centroids";			
		optionsNames = new String[2];
		optionsNames[0] = "min length";
		optionsNames[1] = "threshold";
		resultTypes = new Class[1];
		resultTypes[0] = Class.forName("ij.ImagePlus");
		resultNames = new String[1];
		resultNames[0] = "Result";
	}
	/**
	 * @return Returns the centroids.
	 */
	public ResultsTable getCentroids() {
		if (centroids==null) {
			centroids = ResultsTable.getResultsTable();
		}
		return centroids;
	}
	/**
	 * @param centroids The centroids to set.
	 */
	public void setCentroids(ResultsTable centroids) {
		this.centroids = centroids;
	}
	
	public void doIt() {
		ResultsTable centroids = this.getCentroids();
		ImagePlus inputImage = this.getInputImage();
		result = NewImage.createByteImage(inputImage.getTitle(), inputImage.getWidth(), inputImage.getHeight(), 
											inputImage.getStackSize(), NewImage.GRAY8);
		Vector lines = new Vector();
		for (int index = 0; index < centroids.getCounter(); index++) {
			float x = centroids.getValue(ResultsTable.X_CENTROID, index);
			float y = centroids.getValue(ResultsTable.Y_CENTROID, index);
			// this.findLinesFor(x,y);
			Line2D aLine = this.findLineFor(x,y);
			if (aLine != null)lines.add(aLine);
		}
		for (int i=0; i<lines.size();i++) {
			Line2D aLine = (Line2D) lines.elementAt(i);
			System.out.println((i+1) + ": " + Math.round(aLine.getX1()) + "," + Math.round(aLine.getY1()) + "-" + Math.round(aLine.getX2()) + "," + Math.round(aLine.getY2()));
		}
		FindObjectsOperation findObjects = new FindObjectsOperation();
		findObjects.setMinSize(this.getMinLength());
		findObjects.setInputImage(result);
		findObjects.execute();
		ResultsTable measurements = findObjects.getMeasurements();
		measurements.show("remaining objetcs");
		Vector bestStartLines = new Vector();
		for (int index = 0; index < measurements.getCounter(); index++) {
			float x = measurements.getValue(ResultsTable.X_CENTROID, index);
			float y = measurements.getValue(ResultsTable.Y_CENTROID, index);
			for (int j=0; j<lines.size();j++) {
				Line2D aLine = (Line2D) lines.elementAt(j);
				if (aLine.ptSegDistSq(x,y)<0.1) {
					bestStartLines.add(aLine);
				}
			}
		}
		System.out.println("Best start lines");
		for (int i=0; i<bestStartLines.size();i++) {
			Line2D aLine = (Line2D) bestStartLines.elementAt(i);
			System.out.println((i+1) + ": " + Math.round(aLine.getX1()) + "," + Math.round(aLine.getY1()) + "-" + Math.round(aLine.getX2()) + "," + Math.round(aLine.getY2()));
		}
	}

	/**
	 * @param x
	 * @param y
	 */
	private Line2D findLineFor(float x, float y) {
		Point2D[] startPoints = new Point2D[31];
		Point2D[] endPoints = new Point2D[31];
		double[] averagePixelValues = new double[31];
		analyzeLinesAround(x, y, startPoints, endPoints, averagePixelValues);
		Vector indices = this.getMaxIndices(averagePixelValues);
		int index;
		if (indices.size()==1) {
			index = ((Integer)indices.elementAt(0)).intValue();
		} else {
			index = ((Integer)indices.elementAt(indices.size() / 2)).intValue();
		}
		if (averagePixelValues[index]>=this.getMinMeanGreyLevel()) {
			result.getProcessor().drawLine((int)Math.round(startPoints[index].getX()), (int)Math.round(startPoints[index].getY()), 
					(int)Math.round(endPoints[index].getX()), (int)Math.round(endPoints[index].getY()));
		}
		Line2D result = null;
		if (averagePixelValues[index]>=this.getMinMeanGreyLevel()) {
			result = new Line2D.Float(startPoints[index], endPoints[index]);
		}
		return result;
	}
	
	/**
	 * @param x
	 * @param y
	 * @param startPoints
	 * @param endPoints
	 * @param averagePixelValues
	 */
	private void analyzeLinesAround(float x, float y, Point2D[] startPoints, Point2D[] endPoints, double[] averagePixelValues) {
		float startXOrig = (float) (x - this.getMinLength() / 2.0);
		float startYOrig = y;
		float endXOrig = (float) (x + this.getMinLength() / 2.0);
		float endYOrig = y;
		Point2D fixPoint = new Point.Float(x,y);
		Point2D startPoint = new Point.Float(startXOrig, startYOrig);
		Point2D endPoint = new Point.Float(endXOrig, endYOrig);
		Point2D currentStartPoint;
		Point2D currentEndPoint;
		for (float currentAngle = -15; currentAngle <= 15; currentAngle++) {
			currentStartPoint = this.rotatePointAround(startPoint, fixPoint, currentAngle);
			currentEndPoint = this.rotatePointAround(endPoint, fixPoint, currentAngle);
			double[] pixelValues = inputImage.getProcessor().getLine(currentStartPoint.getX(), currentStartPoint.getY(), 
											  currentEndPoint.getX(), currentEndPoint.getY());
			double averagePixelValue = this.getAverage(pixelValues);
			startPoints[(int)currentAngle+15] = currentStartPoint;
			endPoints[(int)currentAngle+15] = currentEndPoint;
			averagePixelValues[(int)currentAngle+15] = averagePixelValue;
		}
	}

	/**
	 * @param averagePixelValues
	 * @return
	 */
	private Vector getMaxIndices(double[] averagePixelValues) {
		Vector indices = new Vector();
		double max = 0;
		for (int i=0; i<averagePixelValues.length; i++) {
			if (averagePixelValues[i]>max) {
				max = averagePixelValues[i];
			}
		}
		for (int i=0; i<averagePixelValues.length; i++) {
			if (averagePixelValues[i]==max) {
				indices.add(new Integer(i));
			}
		}
		return indices;
	}

	/**
	 * @param pixelValues
	 * @return
	 */
	private double getAverage(double[] pixelValues) {
		double result = 0;
		for (int i=0; i<pixelValues.length; i++) {
			result = result + pixelValues[i];
		}
		result = result / pixelValues.length;
		return result;
	}

	public Point2D rotatePointAround(Point2D point, Point2D fix, float angle) {
		double theAngle = (angle * (Math.PI / 180.0));
		double cosVal = Math.cos(theAngle);
		double sinVal = Math.sin(theAngle);
		double xShifted = (point.getX()- fix.getX());
		double yShifted = (point.getY()- fix.getY());
		double xNew = (xShifted * cosVal - yShifted * sinVal);
		double yNew = (yShifted * cosVal + xShifted * sinVal);
		float xResult = (float) (xNew + fix.getX());
		float yResult = (float) (yNew + fix.getY());
		return new Point.Float(xResult, yResult);
	}
	/**
	 * @return Returns the minLength.
	 */
	public int getMinLength() {
		return minLength.getIntegerValue();
	}
	/**
	 * @param minLength The minLength to set.
	 */
	public void setMinLength(int minLength) {
		this.minLength.setValue(new Double(minLength).toString());
	}
	/**
	 * @return Returns the minMeanGreyLevel.
	 */
	public double getMinMeanGreyLevel() {
		return minMeanGreyLevel.getDoubleValue();
	}
	/**
	 * @param minMeanGreyLevel The minMeanGreyLevel to set.
	 */
	public void setMinMeanGreyLevel(double minMeanGreyLevel) {
		this.minMeanGreyLevel.setValue(new Double(minMeanGreyLevel).toString());
	}
	
	/**
	 * 
	 */
	protected void cleanUpInput() {
		super.cleanUpInput();
		this.setCentroids(null);
	}

	protected void setupOptions() {
		super.setupOptions();
		this.setMinLength(30);
		this.setMinMeanGreyLevel(45);
	}
	
	public void connectOptions() {
		this.minLength = (Option) this.options.getOptions().elementAt(0);
		this.minMeanGreyLevel = (Option) this.options.getOptions().elementAt(1);
	}
	
}
