/*
 * Created on 05.07.2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package operations;

import gui.Option;
import ij.ImagePlus;
import ij.gui.NewImage;

import java.util.Vector;
import java.awt.geom.Line2D;

/**
 * @author Volker
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class ScanForStraightLinesOperation extends Operation {
	/**
	 * 
	 */
	private static final long serialVersionUID = -2223855221596281921L;
	Option threshold;
	Option maxAngle;
	Option countThreshold;
	Vector resultLines;
	/**
	 * @return Returns the treshold.
	 */
	public double getThreshold() {
		return threshold.getDoubleValue();
	}
	/**
	 * @param treshold The treshold to set.
	 */
	public void setTreshold(double threshold) {
		this.threshold.setValue(new Double(threshold).toString());
	}
	
	public ScanForStraightLinesOperation() {
		super();
		resultLines = new Vector();
	}
	
	/**
	 * @param i
	 */
	public void setMaxAngle(int angle) {
		this.maxAngle.setValue(new Integer(angle).toString());
	}
	/**
	 * @throws ClassNotFoundException
	 *  
	 */
	protected void initialize() throws ClassNotFoundException {
		super.initialize();
		// Set parameterTypes, parameterNames and resultType
		parameterTypes = new Class[1];
		parameterTypes[0] = Class.forName("ij.ImagePlus");
		parameterNames = new String[1];
		parameterNames[0] = "InputImage";
		optionsNames = new String[3];
		optionsNames[0] = "threshold";
		optionsNames[1] = "max angle";
		optionsNames[2] = "count threshold";
		resultTypes = new Class[2];
		resultTypes[0] = Class.forName("ij.ImagePlus");
		resultTypes[1] = Class.forName("java.util.Vector");
		resultNames = new String[2];
		resultNames[0] = "Result";
		resultNames[1] = "ResultLines";
		
	}
	
	public void doIt() {
		resultLines = new Vector();
		ImagePlus inputImage = this.getInputImage();
		result = NewImage.createByteImage(inputImage.getTitle(), inputImage.getWidth(), inputImage.getHeight(), 
				inputImage.getStackSize(), NewImage.GRAY8);
		int startX = 0;
		int endX = inputImage.getWidth();
		for (int startY=0; startY<inputImage.getHeight();startY++) {
			for (int angle = -maxAngle.getIntegerValue(); angle<= maxAngle.getIntegerValue(); angle++) {
				int endY = (int)Math.round((Math.sin(angle*(Math.PI / 180.0))*(endX-startX)) + startY); 
				double[] pixelValues = inputImage.getProcessor().getLine(startX, startY, endX, endY);
				double pixelPercentage = this.getCount(pixelValues);
				if (pixelPercentage>countThreshold.getDoubleValue()) {
					Line2D aLine = new Line2D.Float(startX,startY,endX,endY);
					if (resultLines.size()>0 ) {
						Line2D lastLine = (Line2D) resultLines.elementAt(resultLines.size()-1);
						if (lastLine.intersectsLine(aLine)) {
							break;
						}
					}
					resultLines.add(aLine);
				}
			}
		}
		this.drawLines();
	}
	/**
	 * 
	 */
	private void drawLines() {
		for (int i=0; i<resultLines.size();i++) {
			Line2D aLine = (Line2D) resultLines.elementAt(i);
			result.getProcessor().drawLine((int)Math.round(aLine.getX1()), 
										   (int)Math.round(aLine.getY1()), 
										   (int)Math.round(aLine.getX2()), 
										   (int)Math.round(aLine.getY2()));
		}
		
	}

	private double getCount(double[] pixelValues) {
		double result = 0;
		for (int i=0; i<pixelValues.length; i++) {
			if(pixelValues[i]>threshold.getDoubleValue()) result++;
		}
		result = result / pixelValues.length;
		return result;
	}
	/**
	 * @return Returns the countThreshold.
	 */
	public double getCountThreshold() {
		return countThreshold.getDoubleValue();
	}
	/**
	 * @param countThreshold The countThreshold to set.
	 */
	public void setCountThreshold(double countThreshold) {
		this.countThreshold.setValue(new Double(countThreshold).toString());
	}
	
	protected void setupOptions() {
		super.setupOptions();
		this.connectOptions();
		this.setTreshold(30);
		this.setMaxAngle(7);
		this.setCountThreshold(0.33);
	}
	/**
	 * 
	 */
	public void connectOptions() {
		this.threshold = (Option) this.options.getOptions().elementAt(0);
		this.maxAngle = (Option) this.options.getOptions().elementAt(1);
		this.countThreshold = (Option) this.options.getOptions().elementAt(2);
	}
	/**
	 * @return Returns the maxAngle.
	 */
	public int getMaxAngle() {
		return maxAngle.getIntegerValue();
	}
	/**
	 * @return Returns the resultLines.
	 */
	public Vector getResultLines() {
		return resultLines;
	}
	/**
	 * @param resultLines The resultLines to set.
	 */
	public void setResultLines(Vector resultLines) {
		this.resultLines = resultLines;
	}
}
