/*
 * Created on 07.11.2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package particleAnalysis.threeDimensional;

import ij.IJ;
import ij.ImagePlus;
import ij.gui.NewImage;
import ij.measure.ResultsTable;
import ij.process.ImageProcessor;

/**
 * @author Volker
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class MRI_3D_objects_counter extends _3D_objects_counter {
	protected ImagePlus image;
	
	public MRI_3D_objects_counter(ImagePlus anImage, int minSize, int maxSize, boolean displayLabels) {
		super();
		image = anImage;
		this.maxSize = minSize;
		this.maxSize = maxSize;
		this.showNumbers = displayLabels;
		this.showEdges = false;
		this.showParticules = true;
	}
	
	public void run(String arg) {
		img = image;
		image.show();
		if (img == null) {
			IJ.showMessage("Error", "Man,\n" + "You're in deep troubles:\n"
					+ "no opened stack...");
			return;
		}

		ip = img.getProcessor();

		Width = img.getWidth();
		Height = img.getHeight();
		NbSlices = img.getStackSize();
		imgtitle = img.getTitle();

		/*GenericDialog gd = new GenericDialog("Connexity analysis");
		gd.addNumericField("Threshold: ", ip.getAutoThreshold(), 0);
		gd.addNumericField("Min number of voxels: ", 10, 0);
		gd.addNumericField("Max number of voxels: ", Height * Width * NbSlices,
				0);
		gd.addCheckbox("Show particles", true);
		gd.addCheckbox("Show edges", false);
		gd.addCheckbox("Show numbers", false);
		gd.showDialog();

		ThrVal = (int) gd.getNextNumber();
		minSize = (int) gd.getNextNumber();
		maxSize = (int) gd.getNextNumber();
		showParticules = gd.getNextBoolean();
		showEdges = gd.getNextBoolean();
		showNumbers = gd.getNextBoolean();
*/
		this.ThrVal = ip.getAutoThreshold();
		ip.setThreshold(ThrVal, Math.pow(2, 16), ImageProcessor.RED_LUT);

		pict = new int[Height * Width * NbSlices];
		thr = new int[Height * Width * NbSlices];
		tag = new int[Height * Width * NbSlices];
		surf = new boolean[Height * Width * NbSlices];

		//Load the image in a one dimension array
		i = 0;
		for (z = 1; z <= NbSlices; z++) {
			img.setSlice(z);
			for (y = 0; y < Height; y++) {
				for (x = 0; x < Width; x++) {
					int[] tmp = img.getPixel(x, y);
					PixVal = tmp[0];
					setval(x, y, z, PixVal);
					if (PixVal > ThrVal) {
						setthr(x, y, z, 0);
					} else {
						setthr(x, y, z, 1);
					}
					Thread.yield();
				}
			}
		}

		ID = 1;

		for (z = 1; z <= NbSlices; z++) {
			for (y = 0; y < Height; y++) {
				for (x = 0; x < Width; x++) {
					if (getthr(x, y, z) == 0) {
						minTag = gettag(x, y, z);
						//Find the minimum tag in the neighbours pixels
						for (voisZ = -1; voisZ <= 1; voisZ++) {
							for (voisY = -1; voisY <= 1; voisY++) {
								for (voisX = -1; voisX <= 1; voisX++) {
									if (getthr(x + voisX, y + voisY, z + voisZ) == 0) {
										if (gettag(x + voisX, y + voisY, z
												+ voisZ) != 0
												&& gettag(x + voisX, y + voisY,
														z + voisZ) < minTag)
											minTag = gettag(x + voisX, y
													+ voisY, z + voisZ);
									}
								}
							}
						}

						//Set tag to its minimum value according to surrounding pixels
						if (gettag(x, y, z) != 0 && gettag(x, y, z) >= minTag) {
							for (i = 0; i < tag[offset(x + voisX, y + voisY, z
									+ voisZ)]; i++) {
								if (thr[i] == 0 && tag[i] == gettag(x, y, z))
									tag[i] = minTag;
							}
							settag(x, y, z, minTag);
						}
						//Otherwise, we need a new tag 
						if (gettag(x, y, z) == 0) {
							settag(x, y, z, ID);
							ID++;
						}

						//Propagate ID to all neighbouring pixels in x, y and z column + look for edges
						setsurf(x, y, z, false);

						xn = x + 1;
						while (x < Width && getthr(xn, y, z) == 0) {
							settag(xn, y, z, gettag(x, y, z));
							xn++;
						}
						if (xn == x + 1)
							setsurf(x, y, z, true);

						xn = x - 1;
						while (x > 0 && getthr(xn, y, z) == 0) {
							settag(xn, y, z, gettag(x, y, z));
							xn--;
						}
						if (xn == x - 1)
							setsurf(x, y, z, true);

						yn = y + 1;
						while (y < Height && getthr(x, yn, z) == 0) {
							settag(x, yn, z, gettag(x, y, z));
							yn++;
						}
						if (yn == y + 1)
							setsurf(x, y, z, true);

						yn = y - 1;
						while (y > 0 && getthr(x, yn, z) == 0) {
							settag(x, yn, z, gettag(x, y, z));
							yn--;
						}
						if (yn == y - 1)
							setsurf(x, y, z, true);

						zn = z + 1;
						while (z < NbSlices && getthr(x, y, zn) == 0) {
							settag(x, y, zn, gettag(x, y, z));
							zn++;
						}
						if (zn == z + 1)
							setsurf(x, y, z, true);

						zn = z - 1;
						while (z > 1 && getthr(x, y, zn) == 0) {
							settag(x, y, zn, gettag(x, y, z));
							zn--;
						}
						if (zn == z - 1)
							setsurf(x, y, z, true);
					}
					Thread.yield();
				}
			}
			IJ.showStatus("Connexity analysis");
			IJ.showProgress(z, NbSlices);
		}

		//Parameters determination 0:volume; 1:surface; 2:intensity; 3:barycenter x; 4:barycenter y; 5:barycenter z; 6:barycenter x int; 7:barycenter y int; 8:barycenter z int
		Paramarray = new int[ID][9];
		for (z = 1; z <= NbSlices; z++) {
			for (y = 0; y < Height; y++) {
				for (x = 0; x < Width; x++) {
					index = gettag(x, y, z);
					val = getval(x, y, z);
					Paramarray[index][0]++;
					if (getsurf(x, y, z))
						Paramarray[index][1]++;
					Paramarray[index][2] = Paramarray[index][2] + val;
					Paramarray[index][3] = Paramarray[index][3] + x;
					Paramarray[index][4] = Paramarray[index][4] + y;
					Paramarray[index][5] = Paramarray[index][5] + z;
					Paramarray[index][6] = Paramarray[index][6] + x * val;
					Paramarray[index][7] = Paramarray[index][7] + y * val;
					Paramarray[index][8] = Paramarray[index][8] + z * val;
					Thread.yield();
				}
			}
			IJ.showStatus("Retrieving structures' parameters");
			IJ.showProgress(z, NbSlices);
		}
		for (i = 0; i < ID; i++) {
			if (Paramarray[i][0] > minSize && Paramarray[i][0] < maxSize) {
				if (Paramarray[i][0] != 0) {
					Paramarray[i][3] = (int) Paramarray[i][3]
							/ Paramarray[i][0];
					Paramarray[i][4] = (int) Paramarray[i][4]
							/ Paramarray[i][0];
					Paramarray[i][5] = (int) Paramarray[i][5]
							/ Paramarray[i][0];
				}
				if (Paramarray[i][2] != 0) {
					Paramarray[i][6] = (int) Paramarray[i][6]
							/ Paramarray[i][2];
					Paramarray[i][7] = (int) Paramarray[i][7]
							/ Paramarray[i][2];
					Paramarray[i][8] = (int) Paramarray[i][8]
							/ Paramarray[i][2];
				}
			} else {
				for (j = 0; j < 9; j++)
					Paramarray[i][j] = 0;
			}
			IJ.showStatus("Calculating barycenters' coordinates");
			IJ.showProgress(i, ID);
			Thread.yield();
		}

		//Log data
		rt = new ResultsTable();

		String[] head = { "Volume", "Surface", "Intensity", "Center X",
				"Center Y", "Center Z", "Center int X", "Center int Y",
				"Center int Z" };
		for (i = 0; i < head.length; i++)
			rt.setHeading(i, head[i]);

		for (i = 1; i < ID; i++) {
			if (Paramarray[i][0] != 0) {
				rt.incrementCounter();
				for (j = 0; j < 9; j++)
					rt.addValue(j, Paramarray[i][j]);
			}
			Thread.yield();
		}

	//	rt.show("Results from " + imgtitle);

		if (showParticules) {
			Particules = NewImage.createShortImage("Particules " + imgtitle,
					Width, Height, NbSlices, 0);
			Particules.show();
			IJ.run("Fire");
			stackParticules = Particules.getStack();
			Particules.setCalibration(img.getCalibration());
		}

		if (showEdges) {
			Edges = NewImage.createShortImage("Edges " + imgtitle, Width,
					Height, NbSlices, 0);
			Edges.show();
			IJ.run("Fire");
			stackEdges = Edges.getStack();
			Edges.setCalibration(img.getCalibration());
		}

		for (z = 1; z <= NbSlices; z++) {
			for (y = 0; y < Height; y++) {
				for (x = 0; x < Width; x++) {
					if (getthr(x, y, z) == 0) {
						index = gettag(x, y, z);
						if (Paramarray[index][0] > minSize
								&& Paramarray[index][0] < maxSize) {
							if (showParticules) {
								ip = stackParticules.getProcessor(z);
								col = index * Math.pow(2, 16) / ID;
								ip.setValue(col);
								ip.drawPixel(x, y);
							}
							if (showEdges && getsurf(x, y, z)) {
								ip = stackEdges.getProcessor(z);
								col = index * Math.pow(2, 16) / ID;
								ip.setValue(col);
								ip.drawPixel(x, y);
							}	
						}
					}
					Thread.yield();
				}
			}
			IJ.showStatus("Building images");
			IJ.showProgress(z, NbSlices);
		}
		if (showNumbers) {
			for (i = 0; i < rt.getCounter(); i++) {
				if (showParticules) {
					ip = stackParticules.getProcessor((int) rt.getValue(5, i));
					ip.setValue(Math.pow(2, 16));
					ip.drawString("" + (i + 1), (int) rt.getValue(3, i),
							(int) rt.getValue(4, i));
				}
				if (showEdges) {
					ip = stackEdges.getProcessor((int) rt.getValue(5, i));
					ip.setValue(Math.pow(2, 16));
					ip.drawString("" + (i + 1), (int) rt.getValue(3, i),
							(int) rt.getValue(4, i));
				}
				IJ.showStatus("Drawing numbers");
				IJ.showProgress(i, rt.getCounter());
				Thread.yield();
			}
		}

		IJ.showStatus("Nb of particles: " + rt.getCounter());
		IJ.showProgress(2, 1);
		img.hide();
		if (showEdges) {
			Edges.hide();
		}
		if (showParticules) {
			Particules.hide();
		}
	}
	
	public ImagePlus getEdges() {
		return this.Edges;
	}
	
	public ImagePlus getParticles() {
		return this.Particules;
	}
	
	public ResultsTable getMeasurements() {
		return this.rt;
	}
}