package particleAnalysis.threeDimensional;

/*3D objects counter v1.0, 15/06/05
    Fabrice P Cordelires, fabrice.cordelieres at curie.u-psud.fr
*/

import ij.*;
import ij.ImagePlus.*;
import ij.plugin.*;
import ij.plugin.filter.*;
import ij.process.*;
import ij.gui.*;
import ij.measure.*;
import java.awt.*;
import java.util.*;

public class _3D_objects_counter implements PlugIn {
		
                int ThrVal;
                int minSize;
                int maxSize;
                boolean showParticules;
                boolean showEdges;
                boolean showNumbers;
		
		int Width;
		int Height;
		int NbSlices;
		String imgtitle;
		int PixVal;
		int lab;
		
		boolean labbool;
		
                int[] thr;
		int[] pict;
		int[] tag;
                boolean[] surf;
				
		int x;
		int y;
		int z;
                
                int xn;
                int yn;
                int zn;
		
		int i;
		int j;
                int k;
                int tmp;
		
		int ID;
		boolean IDbool;
		int [] IDarray;
                int [][] Paramarray;
		
		int voisX;
		int voisY;
		int voisZ;
                
                int index;
                int val;
                double col;
		
		int minTag;
                int minTagOld;
		
		ImagePlus img;
                ImageProcessor ip;
		ImageStack stackParticules;
                ImageStack stackEdges;
		ImagePlus Particules;
		ImagePlus Edges;
		ResultsTable rt;
                
	
        
				
	public void run(String arg) {
		img=WindowManager.getCurrentImage();
                if (img==null){
			IJ.showMessage("Error", "Man,\n"+"You're in deep troubles:\n"+"no opened stack...");
			return;
		}
                
                ip=img.getProcessor();
                
                Width=img.getWidth();
		Height=img.getHeight();
		NbSlices=img.getStackSize();
		imgtitle = img.getTitle();
                                
                GenericDialog gd=new GenericDialog("Connexity analysis");
                gd.addNumericField("Threshold: ",ip.getAutoThreshold(),0);
                gd.addNumericField("Min number of voxels: ",10,0);
                gd.addNumericField("Max number of voxels: ",Height*Width*NbSlices,0);
                gd.addCheckbox("Show particles",true);
                gd.addCheckbox("Show edges",false);
                gd.addCheckbox("Show numbers",false);
                gd.showDialog();
                
                ThrVal=(int) gd.getNextNumber();
                minSize=(int) gd.getNextNumber();
                maxSize=(int) gd.getNextNumber();
                showParticules=gd.getNextBoolean();
                showEdges=gd.getNextBoolean();
                showNumbers=gd.getNextBoolean();
                
                ip.setThreshold(ThrVal,Math.pow(2,16),ImageProcessor.RED_LUT);
                
		pict=new int [Height*Width*NbSlices];
		thr=new int [Height*Width*NbSlices];
		tag=new int [Height*Width*NbSlices];
                surf=new boolean [Height*Width*NbSlices];
		
	//Load the image in a one dimension array
		i=0;
		for (z=1; z<=NbSlices; z++) {
			img.setSlice(z);
			for (y=0; y<Height;y++) {
				for (x=0; x<Width;x++) {
					int [] tmp=img.getPixel(x, y);
					PixVal=tmp[0];
                                        setval(x,y,z,PixVal);
                                        if (PixVal>ThrVal){
                                            setthr(x,y,z,0);
                                        }else{
                                            setthr(x,y,z,1);
                                        }
                                }
			}
		}
    
		ID=1;
	
		for (z=1; z<=NbSlices; z++){
			for (y=0; y<Height; y++){
				for (x=0; x<Width; x++){
                                    if (getthr(x,y,z)==0){
                                        minTag=gettag(x,y,z);
						//Find the minimum tag in the neighbours pixels
						for (voisZ=-1;voisZ<=1;voisZ++){
							for (voisY=-1;voisY<=1;voisY++){
								for (voisX=-1;voisX<=1;voisX++){
									if (getthr(x+voisX, y+voisY, z+voisZ)==0){
										if (gettag(x+voisX, y+voisY, z+voisZ)!=0 &&	gettag(x+voisX, y+voisY, z+voisZ)<minTag) minTag=gettag(x+voisX, y+voisY, z+voisZ);
									}
								}
							}
						}
						
						//Set tag to its minimum value according to surrounding pixels
						if (gettag(x,y,z)!=0 && gettag(x,y,z)>=minTag){
								for (i=0; i<tag[offset(x+voisX, y+voisY, z+voisZ)];i++) {
											if (thr[i]==0 && tag[i]==gettag(x,y,z)) tag[i]=minTag;
								}
								settag(x,y,z,minTag);
						}
						//Otherwise, we need a new tag 
						if (gettag(x,y,z)==0){
							settag(x,y,z,ID);
							ID++;
						}
						
                                                //Propagate ID to all neighbouring pixels in x, y and z column + look for edges
                                                setsurf(x,y,z,false);
                                                
                                                xn=x+1;
                                                while (x<Width && getthr(xn,y,z)==0){
                                                    settag(xn,y,z,gettag(x,y,z));
                                                    xn++;
                                                }
                                                if (xn==x+1) setsurf(x,y,z,true);
                                                
                                                
                                                xn=x-1;
                                                while (x>0 && getthr(xn,y,z)==0){
                                                    settag(xn,y,z,gettag(x,y,z));
                                                    xn--;
                                                }
                                                if (xn==x-1) setsurf(x,y,z,true);
                                                
                                                
                                                yn=y+1;
                                                while (y<Height && getthr(x,yn,z)==0){
                                                    settag(x,yn,z,gettag(x,y,z));
                                                    yn++;
                                                }
                                                if (yn==y+1) setsurf(x,y,z,true);
                                                
                                                yn=y-1;
                                                while (y>0 && getthr(x,yn,z)==0){
                                                    settag(x,yn,z,gettag(x,y,z));
                                                    yn--;
                                                }
                                                if (yn==y-1) setsurf(x,y,z,true);
                                                
                                                zn=z+1;
                                                while (z<NbSlices && getthr(x,y,zn)==0){
                                                    settag(x,y,zn,gettag(x,y,z));
                                                    zn++;
                                                }
                                                if (zn==z+1) setsurf(x,y,z,true);
                                                
                                                zn=z-1;
                                                while (z>1 && getthr(x,y,zn)==0){
                                                    settag(x,y,zn,gettag(x,y,z));
                                                    zn--;
                                                }
                                                if (zn==z-1) setsurf(x,y,z,true);
                                    }
				}
			}
                IJ.showStatus("Connexity analysis");
                IJ.showProgress(z,NbSlices);
		}

                
//Parameters determination 0:volume; 1:surface; 2:intensity; 3:barycenter x; 4:barycenter y; 5:barycenter z; 6:barycenter x int; 7:barycenter y int; 8:barycenter z int
                Paramarray=new int [ID][9];
                for (z=1; z<=NbSlices; z++){
			for (y=0; y<Height; y++){
				for (x=0; x<Width; x++){
                                    index=gettag(x,y,z);
                                    val=getval(x,y,z);
                                    Paramarray[index][0]++;
                                    if (getsurf(x,y,z)) Paramarray[index][1]++;
                                    Paramarray[index][2]=Paramarray[index][2]+val;
                                    Paramarray[index][3]=Paramarray[index][3]+x;
                                    Paramarray[index][4]=Paramarray[index][4]+y;
                                    Paramarray[index][5]=Paramarray[index][5]+z;
                                    Paramarray[index][6]=Paramarray[index][6]+x*val;
                                    Paramarray[index][7]=Paramarray[index][7]+y*val;
                                    Paramarray[index][8]=Paramarray[index][8]+z*val;
                                }
                        }
                IJ.showStatus("Retrieving structures' parameters");
                IJ.showProgress(z,NbSlices);
                }
                for (i=0;i<ID;i++){
                    if (Paramarray[i][0]>minSize && Paramarray[i][0]<maxSize) {
                        if (Paramarray[i][0]!=0){
                            Paramarray[i][3]=(int) Paramarray[i][3]/Paramarray[i][0];
                            Paramarray[i][4]=(int) Paramarray[i][4]/Paramarray[i][0];
                            Paramarray[i][5]=(int) Paramarray[i][5]/Paramarray[i][0];
                        }
                        if (Paramarray[i][2]!=0){
                            Paramarray[i][6]=(int) Paramarray[i][6]/Paramarray[i][2];
                            Paramarray[i][7]=(int) Paramarray[i][7]/Paramarray[i][2];
                            Paramarray[i][8]=(int) Paramarray[i][8]/Paramarray[i][2];
                        }
                    } else {
                        for (j=0;j<9;j++) Paramarray[i][j]=0;
                    }
                IJ.showStatus("Calculating barycenters' coordinates");
                IJ.showProgress(i,ID);    
                }
                
                               
                
//Log data
	rt=new ResultsTable();
	
	String[] head={"Volume","Surface","Intensity","Center X","Center Y","Center Z","Center int X","Center int Y","Center int Z"};
	for (i=0; i<head.length; i++) rt.setHeading(i,head[i]);		
	             
        for (i=1;i<ID;i++){
		if (Paramarray[i][0]!=0){
                    rt.incrementCounter();
                    for (j=0; j<9; j++) rt.addValue(j,Paramarray[i][j]);
                }
        }
				
		rt.show("Results from "+imgtitle);
	
                if (showParticules){
                    Particules=NewImage.createShortImage("Particules "+imgtitle,Width,Height,NbSlices,0);
                    Particules.show();
                    IJ.run("Fire");
                    stackParticules=Particules.getStack();
                    Particules.setCalibration(img.getCalibration());
                }
                
                if (showEdges){
                    Edges=NewImage.createShortImage("Edges "+imgtitle,Width,Height,NbSlices,0);
                    Edges.show();
                    IJ.run("Fire");
                    stackEdges=Edges.getStack();
                    Edges.setCalibration(img.getCalibration());
                }
		
		for (z=1; z<=NbSlices; z++){
			for (y=0; y<Height; y++){
				for (x=0; x<Width; x++){
                                    if (getthr(x,y,z)==0){
                                        index=gettag(x,y,z);
                                        if (Paramarray[index][0]>minSize && Paramarray[index][0]<maxSize){
                                            if (showParticules){
                                                ip=stackParticules.getProcessor(z);
                                                col=index*Math.pow(2,16)/ID;
                                                ip.setValue (col);
                                                ip.drawPixel(x, y);
                                            }
                                            if (showEdges && getsurf(x,y,z)){
                                                ip=stackEdges.getProcessor(z);
                                                col=index*Math.pow(2,16)/ID;
                                                ip.setValue (col);
                                                ip.drawPixel(x, y);
                                            }
                                        }
                                    }
                                }
                        }
                IJ.showStatus("Building images");
                IJ.showProgress(z,NbSlices);
                }
                if (showNumbers){
                    for (i=0;i<rt.getCounter();i++){
                        if (showParticules){
                            ip=stackParticules.getProcessor((int)rt.getValue(5,i));
                            ip.setValue(Math.pow(2,16));
                            ip.drawString(""+(i+1),(int)rt.getValue(3,i),(int)rt.getValue(4,i));
                        }
                        if (showEdges){
                            ip=stackEdges.getProcessor((int)rt.getValue(5,i));
                            ip.setValue(Math.pow(2,16));
                            ip.drawString(""+(i+1),(int)rt.getValue(3,i),(int)rt.getValue(4,i));
                        }
                    IJ.showStatus("Drawing numbers");
                    IJ.showProgress(i,rt.getCounter());
                    }
                }
				
		
		
		IJ.showStatus("Nb of particles: "+rt.getCounter());
                IJ.showProgress(2,1);
}
        	
	public int offset(int m,int n,int o){
		if (m+n*Width+(o-1)*Width*Height>=Width*Height*NbSlices){
			return Width*Height*NbSlices-1;
			}else{		
				if (m+n*Width+(o-1)*Width*Height<0){
					return 0;
					}else{
					return m+n*Width+(o-1)*Width*Height;
				}
			}
	}
	public void setval(int m,int n,int o,int val){
		if (offset(m,n,o)<pict.length && offset(m,n,o)>0) pict[offset(m,n,o)]=val;
	}
	
	public int getval(int m,int n,int o){
		if (offset(m,n,o)<pict.length && offset(m,n,o)>0) {
			return pict[offset(m,n,o)];
			}else{
				return 0;
			}
	}
        
	public void setthr(int m,int n,int o,int val){
		if (offset(m,n,o)<thr.length && offset(m,n,o)>0) thr[offset(m,n,o)]=val;
	}
	
	public int getthr(int m,int n,int o){
		if (offset(m,n,o)<thr.length && offset(m,n,o)>0) {
			return thr[offset(m,n,o)];
			}else{
				return 255;
			}
	}
	
	public void settag(int m,int n,int o,int val){
		if (offset(m,n,o)<thr.length && offset(m,n,o)>0) tag[offset(m,n,o)]=val;
	}
	
	public int gettag(int m,int n,int o){
		if (offset(m,n,o)<thr.length && offset(m,n,o)>0) {
			return tag[offset(m,n,o)];
			}else{
				return 0;
			}
	}
        
        public void setsurf(int m,int n,int o,boolean val){
		if (offset(m,n,o)<surf.length && offset(m,n,o)>0) surf[offset(m,n,o)]=val;
	}
	
	public boolean getsurf(int m,int n,int o){
		if (offset(m,n,o)<surf.length && offset(m,n,o)>0) {
			return surf[offset(m,n,o)];
			}else{
				return false;
			}
	}
	
	public void replacetag(int m,int n){
		for (z=1; z<=NbSlices; z++){
			for (y=0; y<Height; y++){
				for (x=0; x<Width; x++){
                                    if (gettag(x,y,z)==m) settag(x,y,z,n);
                                }
                        }
                }
        }
}

