/*
 * Created on 13.08.2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package processingOperations;

import operations.Operation;
import gui.Option;
import ij.ImagePlus;
import ij.ImageStack;
import ij.process.ImageProcessor;


/**
 * @author Volker
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class ErodeOperation extends Operation {
	/**
	 * 
	 */
	private static final long serialVersionUID = 1577451507283585363L;
	Option numberOfTimes;
	
	protected void initialize() throws ClassNotFoundException {
		super.initialize();
		optionsNames = new String[1];
		optionsNames[0] = "number of times";
		parameterTypes = new Class[1];
		parameterTypes[0] = Class.forName("ij.ImagePlus");
		parameterNames = new String[1];
		parameterNames[0] = "InputImage";
		resultTypes = new Class[1];
		resultTypes[0] = Class.forName("ij.ImagePlus");
		resultNames = new String[1];
		resultNames[0] = "Result";
	}
	
	public void doIt() {
		ImagePlus inputImage = this.getInputImage();
		result = this.getCopyOfOrReferenceTo(inputImage, inputImage.getTitle());
		this.processSlices();
	}
	
	protected void doItForSlice(int sliceNumber, ImageStack stack) {
		ImageProcessor ip = stack.getProcessor(sliceNumber);
		for (int i=0; i< this.getNumberOfTimes(); i++) ip.erode();
	}
	/**
	 * @return Returns the numberOfTimes.
	 */
	public int getNumberOfTimes() {
		return numberOfTimes.getIntegerValue();
	}
	/**
	 * @param numberOfTimes The numberOfTimes to set.
	 */
	public void setNumberOfTimes(int numberOfTimes) {
		this.numberOfTimes.setValue(Integer.toString(numberOfTimes));
	}
	
	public void connectOptions() {
		this.numberOfTimes = (Option) this.options.getOptions().elementAt(0);
	}
	
	protected void setupOptions() {
		super.setupOptions();
		this.setNumberOfTimes(1);
		this.numberOfTimes.setMin(1);
		this.numberOfTimes.setShortHelpText("enter the number of times the operation is applied");
	}
}
