package reportingOperations;

import ij.measure.ResultsTable;
import reporting.ExcelIO;
import reporting.ExcelWriter;

public class ReportPointMeasurementsOperation extends ReportMeasurementsOperation {

	/**
	 * 
	 */
	private static final long serialVersionUID = -2941071719574518606L;

	public ReportPointMeasurementsOperation() {
		super();
		// TODO Auto-generated constructor stub
	}
	
	protected String headingsFirstSheet() {
		String headings = "image\tnumber of objects";
		headings = headings + "\tX"+ "\tY" + "\tZ" + "\tValue" + "\tfolder";
		return headings;
	}
	
	protected String headingsSecondSheet() {
		String headings = "image";
		headings = headings + "\tNr.\tX"+ "\tY" + "\tZ" + "\tValue"; 
		headings = headings + "\tfolder";
		return headings;
	}
	
	protected void reportAverage(ExcelIO excelIO, ExcelWriter excelProxy) {
		excelProxy.setSheet(excelIO.wb.getSheetAt(0));
		String row = this.getImageName() + "\t";
		int count = this.getMeasurements().getCounter();
		if (this.getMeasurements().getColumnIndex("Value") == ResultsTable.COLUMN_NOT_FOUND) {
			count = 0;
			row = row + count + "\t \t \t \t \t";
		} else {
			row = row + count + "\t";
			for (int i = 0; i < ResultsTable.MAX_COLUMNS; i++) {
				String data = this.getAverageForColumn(i);
				if (data != null) {
					row = row + this.getAverageForColumn(i) + "\t";
				}
			}
		}
		row = row + this.getImageFolder();
		excelProxy.writeTabSeparatedDataAsRow(row);
		excelProxy.setSheet(excelIO.wb.getSheetAt(1));
	}
	
	/**
	 * 
	 */
	protected void reportMeasurement(ExcelIO excelIO, ExcelWriter excelProxy, int i) {
		excelProxy.setSheet(excelIO.wb.getSheetAt(1));
		if (this.getMeasurements().getColumnIndex("Value") == ResultsTable.COLUMN_NOT_FOUND) {
			// noop
		} else {
			String row = this.getImageName() + "\t";
			row = row + this.getMeasurements().getRowAsString(i) + "\t";
			row = row + this.getImageFolder();
			excelProxy.writeTabSeparatedDataAsRow(row);
		}
		excelProxy.setSheet(excelIO.wb.getSheetAt(1));
	}
}
