package stackRegistration;

import ij.IJ;
import ij.ImagePlus;
import ij.gui.Roi;
import ij.util.Java2;

import java.awt.Graphics;
import java.awt.Image;
import java.awt.Rectangle;
import javax.swing.JFrame;
import javax.swing.JPanel;


public class ImageCanvas extends ij.gui.ImageCanvas {
	/**
	 * 
	 */
	private static final long serialVersionUID = 3911048278762863753L;
	protected ImagePlus image;
	protected ImagePlus secondImage;
	protected int offsetX;
	protected int offsetY;
	protected int secondImageOffsetX;
	protected int secondImageOffsetY;
	protected int scrollX = 0;
	protected int scrollY = 0;

	public ImageCanvas() {
		super(new ImagePlus());
		// TODO Auto-generated constructor stub
	}
	
	public void setImage(ImagePlus anImage) {
		image = anImage;
		updateImage(anImage);
	}
	void updateImage(ImagePlus imp) {
		this.imp = imp;
		int width = imp.getWidth();
		int height = imp.getHeight();
		imageWidth = width;
		imageHeight = height;
		// srcRect = new Rectangle(0, 0, imageWidth, imageHeight);
		srcRect = new Rectangle(0, 0, 2000, 2000);
		setDrawingSize(2000, 2000);
		magnification = 1.0;
	}
	
	public void update(Graphics graphics) {
		super.update(graphics);
		//this.paint(graphics);
	}
	public void paint(Graphics graphics) {
		graphics.translate(-scrollX, -scrollY);
		int zeroX = this.getParent().getWidth() / 2 - image.getWidth() / 2;
		int zeroY = this.getParent().getHeight() / 2 - image.getHeight() / 2;
		Roi roi = imp.getRoi();
		if (roi != null) roi.updatePaste();
		try {
			if (imageUpdated) {
				imageUpdated = false;
				imp.updateImage();
			}
			if (IJ.isJava2()) {
				if (magnification<1.0)
					 Java2.setBilinearInterpolation(graphics, true);
				else if (IJ.isMacOSX())
					Java2.setBilinearInterpolation(graphics, false);
			}
			Image img = imp.getImage();
			if (img!=null)
				graphics.clearRect(0,0,2000,2000);
				// graphics.drawImage(image.getImage(), zeroX + offsetX, zeroY + offsetY, this);
				//graphics.drawImage(img, 0, 0, (int)(srcRect.width*magnification), (int)(srcRect.height*magnification),
				// srcRect.x, srcRect.y, srcRect.x+srcRect.width, srcRect.y+srcRect.height, null);
				graphics.drawImage(img, zeroX + offsetX, zeroY + offsetY, (int)(zeroX + offsetX+(image.getWidth()*magnification)), (int)(zeroY + offsetY+(image.getHeight()*magnification)),
						0, 0, (int)(image.getWidth()), (int)(image.getHeight()), this);
				if (secondImage!=null) {
					graphics.drawImage(secondImage.getImage(), zeroX + secondImageOffsetX, zeroY + secondImageOffsetY, (int)(zeroX + secondImageOffsetX+(image.getWidth()*magnification)), (int)(zeroY + secondImageOffsetY+(image.getHeight()*magnification)),
							0, 0, (int)(image.getWidth()), (int)(image.getHeight()), this);
				}
			if (roi != null) roi.draw(graphics);
		//	if (IJ.debugMode) showFrameRate(graphics);
		}
		catch(OutOfMemoryError e) {IJ.outOfMemory("Paint");}
	}

	public void zoomOut(int x, int y) {
		super.zoomOut(x,y);
		validateWindow();
	}

	public void validateWindow() {
		JFrame win = (JFrame)(((JPanel)(this.getParent())).getTopLevelAncestor());
		win.validate();
	}
	
	public void zoomIn(int x, int y) {
		super.zoomIn(x,y);
		validateWindow();
	}
	
	public void setXOffset(int offsetX) {
		this.offsetX = offsetX;
	}
	
	public void setYOffset(int offsetY) {
		this.offsetY = offsetY;
	}

	public int getScrollX() {
		return scrollX;
	}

	public void setScrollX(int scrollX) {
		this.scrollX = scrollX;
	}

	public int getScrollY() {
		return scrollY;
	}

	public void setScrollY(int scrollY) {
		this.scrollY = scrollY;
	}

	public ImagePlus getSecondImage() {
		return secondImage;
	}

	public void setSecondImage(ImagePlus secondImage) {
		this.secondImage = secondImage;
	}

	public int getSecondImageOffsetX() {
		return secondImageOffsetX;
	}

	public void setSecondImageOffsetX(int secondImageOffsetX) {
		this.secondImageOffsetX = secondImageOffsetX;
	}

	public int getSecondImageOffsetY() {
		return secondImageOffsetY;
	}

	public void setSecondImageOffsetY(int secondImageOffsetY) {
		this.secondImageOffsetY = secondImageOffsetY;
	}
}
