package stackRegistration;

import gui.ProgressBar;

import java.io.File;
import java.util.Iterator;
import java.util.Observable;
import java.util.Vector;

import applications.Application;

public class ScaleSlices extends Observable implements Runnable {
	protected File targetFile;
	protected Vector translations;
	protected Thread task;
	protected Application application;
	protected boolean showProgress;
	protected ProgressBar progress;
	
	public ScaleSlices(Vector translations, File targetFile, Application application) {
		this.translations = translations;
		this.targetFile = targetFile;
		this.application = application;
	}

	public boolean isShowProgress() {
		return showProgress;
	}

	public void setShowProgress(boolean showProgress) {
		this.showProgress = showProgress;
	}
	
	public void execute() { 
		if (this.isShowProgress()) {
			progress = new ProgressBar(0, translations.size()-1, "treating slices");
			progress.setCloseWhenFinished(true);
			progress.getView().setVisible(true);
		}
		this.task = new Thread(this);
		task.start();
	}

	public void run() {
		Iterator it = translations.iterator();
		while(it.hasNext()) {
			AlignmentSlice currentTranslation = (AlignmentSlice)it.next();
			currentTranslation.setApplication(this.application);
			currentTranslation.scale(targetFile);
			if (isShowProgress()) progress.setProgress(progress.getProgress() + 1);
			Thread.yield();
		}
		this.changed("running");
		this.deleteObservers();
	}

	public Thread getTask() {
		return task;
	}

	public void setTask(Thread task) {
		this.task = task;
	}
	
	public void changed(String string) {
		this.setChanged();
		this.notifyObservers(string);
		this.clearChanged();
	}
}
