package stackRegistration;

import java.util.Vector;

import javax.swing.table.AbstractTableModel;
import javax.swing.table.TableModel;

public class Translations extends AbstractTableModel implements TableModel {

	/**
	 * 
	 */
	private static final long serialVersionUID = -2690300221461261456L;
	protected Vector translations;
	
	public Translations() {
		super();
		// TODO Auto-generated constructor stub
	}

	public Translations(Vector theTranslations) {
		super();
		this.translations = theTranslations;
		this.fireTableRowsInserted(0, theTranslations.size()-1);
		this.fireTableDataChanged();
	}
	
	public int getRowCount() {
		return this.getTranslations().size();
	}

	public int getColumnCount() {
		return 4;
	}

	public String getColumnName(int index) {
		String[] columnNames = {"nr.", "x", "y", "score"};
		return columnNames[index];
	}

	public Class getColumnClass(int index) {
		Class[] classes = {Integer.class, Integer.class, Integer.class, Double.class};
		return classes[index];
	}

	public boolean isCellEditable(int rowIndex, int columnIndex) {
		if (columnIndex == 0) return false; 
		return true;
	}

	public Object getValueAt(int rowIndex, int columnIndex) {
		Object result = null;
		AlignmentSlice row = (AlignmentSlice) this.getTranslations().elementAt(rowIndex);
		if (columnIndex == 0) return new Integer(rowIndex+1);
		if (columnIndex == 1) return new Integer(row.getXOffset());
		if (columnIndex == 2) return new Integer(row.getYOffset());
		if (columnIndex == 3) return new Double(row.getScore());
		return result;
	}

	public void setValueAt(Object aValue, int rowIndex, int columnIndex) {
		if (columnIndex==0) return;
		if (columnIndex==1) ((AlignmentSlice)(this.getTranslations().elementAt(rowIndex))).setXOffset((Integer)aValue);
		if (columnIndex==2) ((AlignmentSlice)(this.getTranslations().elementAt(rowIndex))).setYOffset((Integer)aValue);
		if (columnIndex==3) ((AlignmentSlice)(this.getTranslations().elementAt(rowIndex))).setScore((Double)aValue);
		fireTableCellUpdated(rowIndex, columnIndex);
	}

	public Vector getTranslations() {
		if (translations==null) {
			translations = new Vector();
		}
		return translations;
	}

	public void setTranslations(Vector translations) {
		this.translations = translations;
		this.fireTableRowsInserted(0, translations.size()-1);
		this.fireTableDataChanged();
	}
}
