package utils;

import java.io.File;

import javax.swing.JFileChooser;

import ij.io.OpenDialog;
import ij.io.SaveDialog;

public class FileFromUser {

	public FileFromUser() {
		super();
		// TODO Auto-generated constructor stub
	}

	static public File getSaveFile(String title, String type, String extension) {
		File result = null;
		String defaultDir = OpenDialog.getDefaultDirectory();
		SaveDialog saveDialog = new SaveDialog(title, type, extension);
		String filename = saveDialog.getFileName();
		String path = null;
		if (filename==null) {
			return result;
		}
		String folder = saveDialog.getDirectory();
		path = folder + filename;
		result = new File(path);
		OpenDialog.setDefaultDirectory(defaultDir);
		return result;
	}
	
	static public File getOpenFile(String title, String type, String extension) {
		File result = null;
		String defaultDir = OpenDialog.getDefaultDirectory();
		OpenDialog openDialog = new OpenDialog(title, type, extension);
		String filename = openDialog.getFileName();
		String path = null;
		if (filename==null) {
			return result;
		}
		String folder = openDialog.getDirectory();
		path = folder + filename;
		result = new File(path);
		OpenDialog.setDefaultDirectory(defaultDir);
		return result;
	}
	
	static public File getFolder(String title, String type, String extension) {
		JFileChooser fileChooser = new JFileChooser();
		if (OpenDialog.getDefaultDirectory()!=null) {
			fileChooser.setCurrentDirectory(new File(OpenDialog.getDefaultDirectory()));
		}
		fileChooser.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
		fileChooser.setMultiSelectionEnabled(false);
		int returnVal = fileChooser.showOpenDialog(null);
		if (returnVal != JFileChooser.APPROVE_OPTION) return null;
		File aFile = fileChooser.getSelectedFile();
		String currentFolder = fileChooser.getSelectedFile().getAbsolutePath();
		if (!aFile.isDirectory()) {
			currentFolder = fileChooser.getSelectedFile().getParent();
		}
		OpenDialog.setDefaultDirectory(currentFolder);
		return aFile;
	}
}
