package utils;

import ij.ImagePlus;
import ij.plugin.filter.Duplicater;
import ij.process.ImageProcessor;

public class ImageTransformer {
	
	public static ImagePlus shift(ImagePlus image, int xShift, int yShift) {
		int height = image.getHeight();
		int width = image.getWidth();
		Duplicater copyAction = new Duplicater();
		ImagePlus result = copyAction.duplicateStack(image, image.getTitle() + " shifted");
		result.setImage(result.getProcessor().createImage());
		ImageProcessor ip = result.getProcessor();
		for(int y=0;y<height;y++) {
			for(int x=0;x<width;x++)
				ip.putPixelValue(x,y,image.getPixel(x-xShift,y-yShift)[0]);
		}
		return result;
	}

}
